package logica.gui;


import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class BarChart 
extends MapVisualization
{
	private int margin = 2;
	private int leftMargin = 130;
	
	private MapElement[] region = new Bar[buffersize];
	
        
    	public BarChart(int width, int height)
    	{		
		super(width,height);		
	}
	
	
	public void paint(Graphics g)
	{	
		//g.setColor(Color.black);
		//g.fillRect(0,0,w,h);
		super.paint(g);
	}
	
	public void addRegion(String name, int id, float x, float y, float value)
	{
		region[nrOfRegions] = new Bar(name, id, value);		
		region[nrOfRegions].addMouseListener(this);
		nrOfRegions++;
		if (nrOfRegions >= buffersize) 
		{
			buffersize += 10;
			MapElement[] temp = new Bar[buffersize];
			System.arraycopy(region,0,temp,0,region.length);
			region = temp;
		}		
	}	
	
		
	void arrange()
	{
		removeAll();
		
		setLayout(null);
		setBackground(new Color(50,50,50));		
		setSize(w,h);
		
		add(regionLabel);
		
		sortByValue(region);
		scaleToFit(region, 3.0F, h - 10);
		
		//int barWidth = (int) (((float) w - ((float)nrOfRegions * (float)margin)) / (float)nrOfRegions);
		int barWidth = (int) ((float) (w - leftMargin + 10 - nrOfRegions*margin) /  (float) (nrOfRegions));
		
		for(int i = 0 ; i < nrOfRegions; i++)
		{
			//region[i].setBounds(margin + i*(barWidth + margin), h - 200, 10, 200);
			region[i].setLocation(leftMargin + (nrOfRegions - i) * (barWidth + margin) - barWidth, h - region[i].getHeight());
			region[i].setWidth(barWidth);
			add(region[i]);				
		}		

		// Fr unser Null-Layout wahrscheinlich nicht notwendig aber trotzdem
		invalidate();
		repaint();
		doLayout();
		
		Container owner = getParent();
		if (owner != null) 
		{
			owner.invalidate();
			owner.doLayout();
		}
	}
	
	public void reArrange()
	{
		arrange();
	}	
	
	public void setNewData(float[] values)
	{
		sortById(region);
		for (int i = 0; i < nrOfRegions; ++i) 
		{	
			if (i < values.length) {
				region[i].setValue(values[i]);
				region[i].setAbsValue(values[i]);
			}
			else {
				region[i].setValue(0);								// ist der array zu kurz wert auf null setzen
				region[i].setAbsValue(0);							// ueberschuessige elemnte zu langer array werden ignoriert
			}
		}
		arrange();
	}
			
	public void activate(int id)
	{
		for (int i = 0; i < nrOfRegions; i++)
		{
			if (region[i].getActive()) region[i].setActive(false);
			if (region[i].getId() == id) region[i].setActive(true);
		}
	}

	
	void scaleToFit(MapElement[] object, float min, float max)
	{
        
		float v_max = (float) 0.0F;        
        
        	for (int i=0; i < nrOfRegions; i++)
	        {
        	    v_max = Math.max(object[i].getValue(),v_max);
        	}  
               
        
		for (int i=0; i < nrOfRegions; i++)
        	{
            		object[i].setValue( (object[i].getValue() / v_max) * max );
			if (object[i].getValue() < min) object[i].setValue(min);
        	}    
    	}	

}
    

    
    
     
     
     
     




