
package logica.gui;

import java.awt.*;
import java.awt.event.*;


public class CloseButton 
extends Component
implements MouseListener
{
	private String name;
		
	private int w;
	private int h;
	
	private int margin = 3;

	private boolean hasFocus;
	private boolean isActive;	
	
	private ActionListener actionListener;

	
	public CloseButton()
	{
		this("close");
	}
	
	public CloseButton(String name)
	{
		super();        
		this.name = name;
		
		hasFocus = false;
		isActive = false;		
		
		h = 10;
		w = 10;		
		setSize(w+1,h+1);		
				
		addMouseListener(this);
	}
	
	public void paint(Graphics g)
	{
		g.setFont(Style.defaultFont);
		if (isActive)
		{
			g.setColor(Color.white);
			g.drawLine(margin, margin, w - margin, h - margin);
			g.drawLine(margin, h-margin, w - margin, margin);			
		}
		else if(hasFocus)
		{
			g.setColor(Color.white);
			g.drawLine(margin, margin, w - margin, h - margin);
			g.drawLine(margin, h-margin, w - margin, margin);			
		}
		else 
		{
			g.setColor(Style.textLight);		
			g.drawLine(margin, margin, w - margin, h - margin);
			g.drawLine(margin, h-margin, w - margin, margin);				
		}		  
		g.setColor(Style.defaultBorder);			
		g.drawRect(0,0,w,h);			
	}	
        
	
	
	public int getWidth()
	{
		return w + 1;
	}
	
	public int getHeight()
	{
		return h + 1;
	}
	
	
	public boolean isFocusTraversable()
	{
		return true;
	}	


	public void addActionListener(ActionListener listener)
	{
		actionListener = AWTEventMulticaster.add(actionListener, listener);
		enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	}
		
	public void removeActionListener(ActionListener listener)
	{
		actionListener = AWTEventMulticaster.remove(actionListener, listener);
	}		
	

		
	public void mouseClicked(java.awt.event.MouseEvent e) 
	{
	}	

	public void mouseEntered(java.awt.event.MouseEvent e) 
	{
			requestFocus();	
			hasFocus = true;
			repaint();		
	}
	
	public void mouseExited(java.awt.event.MouseEvent e) 
	{
			hasFocus = false;
			repaint();		
	}
	
	public void mousePressed(java.awt.event.MouseEvent e) 
	{
	}
	
	public void mouseReleased(java.awt.event.MouseEvent e)
	{
			if(actionListener != null) 
			{
				actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, "close"));				
			}			
			repaint();			
	}
	

}
	 



