package logica.gui;


import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class Dialog
extends Container
implements ActionListener
{					
	private int w;
	private int h;
	private String msg = "";

	private NullComponent blockerBg;
	private OKButton okButton;
	
	private int textfield_w = 300;
	private int textfield_h = 200;
	
	private boolean okPressed = false;
	
	private ActionListener actionListener;
			
        
	public Dialog(int width, int height)
    	{		
		super();
		
		w = width;
		h = height;
			
		setLayout(null);			
		setSize(w,h);
		
		okButton = new OKButton();
		okButton.addActionListener(this);
		okButton.setLocation( w/2 - okButton.getWidth()/2, h/2 + 10);		
		//okButton.setVisible(false);
		add(okButton);
		
		blockerBg = new NullComponent(w,h);
		blockerBg.setLocation(0,0);
		blockerBg.setSize(w,h);
		add(blockerBg);														
	}
	
	public void setText(String msg)
	{
		this.msg = msg;
		repaint();
	}
	
	public void waitForOK()
	{
		okButton.setLocation( w/2 - okButton.getWidth()/2, h/2 + 10);
		okButton.setVisible(true);
		repaint();
			
	}
	
	public void showOK(boolean stat)
	{
		okButton.setVisible(stat);
		repaint();
			
	}	

	public boolean isReady()
	{
		return (! this.isVisible());			
	}	
	
	public void paint(Graphics g)
	{			
		g.setFont(Style.defaultFont);
		FontMetrics fm = getFontMetrics(Style.defaultFont);

		g.setColor(Color.black);
		g.fillRect((w-textfield_w)/2, (h-textfield_h)/2, textfield_w, textfield_h);

		g.setColor(Style.defaultBorder);
		g.drawRect((w-textfield_w)/2, (h-textfield_h)/2, textfield_w, textfield_h);
						
						
		g.setColor(Color.white);		
		g.drawString(msg, w/2 - fm.stringWidth(msg)/2, h/2 - 20);		
				
		super.paint(g);
	}
		
	public int getWidth()
	{
		return w;
	}
	
	public int getHeight()
	{
		return h;
	}	
	
	
	public void actionPerformed(ActionEvent e)
	{
		String cmd = e.getActionCommand();
		if(cmd.equals("OK"))		
		{
			this.setVisible(false);
			repaint();
		}
	}				
			
}
    

    
    
     
     
     
     

