package logica.gui;


import java.awt.*;


public class FlyingLabel 
extends Component
{
	private String text;
	private int w;
	private int h;
	
	private int topMargin = 2;
	private int leftMargin = 10;	
	private FontMetrics fm;
	
	public FlyingLabel() 
	{
		this("");
	}
	
	public FlyingLabel(String text) 
	{		
		super();
		
		this.text = text;
		//this.setVisible(false);
		
		setFont(Style.defaultFont);
		fm = getFontMetrics(Style.defaultFont);
		
		h = Style.defaultFontHeight + (2 * topMargin) +1;
		w = fm.stringWidth(text) + (2 * leftMargin);		
		setSize(w,h);
	}	
	
	
	public void setText(String text)
	{
		this.text = text;
	
		h = Style.defaultFontHeight + (2 * topMargin) + 1;
		w = fm.stringWidth(text) + (2 * leftMargin);		
		setSize(w,h);
	}
	
	
	public String getText()
	{
		return this.text;
		
	}	
	
	
	public void setMargin(int top, int left)
	{
		this.topMargin = top;
		this.leftMargin = left;		
	}
	
	
	public Dimension getPreferredSize()
	{
		return new Dimension(w,h);
	}

	
	public Dimension getMinimumSize()
	{
		return new Dimension(w,h);
	}	
	
	
	public boolean isFocusTraversable()
	{
		return false;
	}	
	
	public int getHeight()
	{
		return h;
	}			

	public int getWidth()
	{
		return w;
	}				
		
	public void paint(Graphics g)
	{
		//setFont(Style.defaultFont);

		setSize(w,h);
		
		//g.setColor(Style.defaultColor);
		//g.setColor(Color.black);
		
		g.setColor(Color.white);		
		g.fillRect(0,0,w-1,h-1);
		
		//g.setColor(Style.defaultBorder);
		//g.drawRect(0,0,w-1,h-1);		

		g.setColor(Color.black);	
		g.drawString(text, leftMargin, Style.defaultFontHeight + topMargin - 1);
	}
	
	
}
