package logica.gui;


import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;

import logica.utility.*;

public class Graph 
extends Container 
implements MouseMotionListener, MouseListener
{
			
	private float[] data2plot;
	private float[] data;	
	private int[] coordArr;
		
	private int w;
	private int h;
	private int actYear;
	
	private FlyingLabel label;
	private NumberFormat nf;	
        
	public Graph(int width, int height)
    	{		
		super();
		w = width;
		h = height;
		setSize(w,h);

		label = new FlyingLabel("");
		add(label);
		label.setVisible(false);

		coordArr = new int[w];
		for(int i=0;i<w;i++) coordArr[i] = 0;
		nf = NumberFormat.getInstance();
		
		addMouseMotionListener(this);
		addMouseListener(this);				
	}
	
	
	
	public void paint(Graphics g)
	{	
		g.setColor(Style.LightGrey);
		plotActLine(g);
							
		g.setColor(Style.graphColor1);		
		plotGraph(g);	
				
		super.paint(g);
	}
	
	public void plotGraph(Graphics g)
	{
		for(int i=0; i<w-1; i++)
		{
			g.drawLine(i,coordArr[i],i+1,coordArr[i+1]);
		}
		
	}
	
	public void plotActLine(Graphics g)
	{
		int x = (int) ( (float) actYear * (float) w / (float) data2plot.length);
		g.drawLine(x, 1, x, h-1);	
	}			
	
	public void loadData(float[] values)
	{
		data = values;
		data2plot = Norm.normalize(values);
		for(int i=0; i < w; i++)
		{
			int val = (int) ( Math.max(0,data2plot[(int) ( (float) i * (float) data2plot.length / (float) w)]) * (float) (h -20));
			coordArr[i] = h - 5 - val;
		}
		repaint();
		
	}
	
	public float getValueAt(int x)
	{
		return data[ (int) ((float) data.length / (float) w * (float) x)];	
	}
			
	public void setActYear(int yr)
	{
		actYear = yr;
	}	
	
	
	public void mouseEntered(MouseEvent e)
	{	
		label.setText(nf.format(getValueAt(e.getX())));
			
		//Point newPos = new Point(e.getLocation());
		Point newPos = new Point(e.getX() - 10 ,e.getY() - label.getHeight() - 10);
		
		newPos.x = Math.max(5,newPos.x);
		newPos.y = Math.max(5,newPos.y);
			
		newPos.x = Math.min(w  - label.getWidth() - 5 ,newPos.x);
		newPos.y = Math.min(h - label.getHeight() - 5 ,newPos.y);
			
		label.setLocation(newPos);
		label.setVisible(true);	
		repaint();
	}	
		
	public void mouseReleased(MouseEvent e){}

	public void mouseExited(MouseEvent e)
	{
		label.setVisible(false);
	}	
	
	public void mouseClicked(MouseEvent e)
	{
	}		
				
	public void mousePressed(MouseEvent e)
	{
	}	
	
	public void mouseMoved(MouseEvent e) 
	{
		label.setText(nf.format(getValueAt(e.getX())));
			
		//Point newPos = new Point(e.getLocation());
		Point newPos = new Point(e.getX() - 10 ,e.getY() - label.getHeight() - 10);
		
		newPos.x = Math.max(5,newPos.x);
		newPos.y = Math.max(5,newPos.y);
			
		newPos.x = Math.min(w  - label.getWidth() - 5 ,newPos.x);
		newPos.y = Math.min(h - label.getHeight() - 5 ,newPos.y);
			
		label.setLocation(newPos);
		label.setVisible(true);	
		repaint();	
	
	}	
	
	public void mouseDragged(MouseEvent e) {}						
}
    

    
    
     
     
     
     

