
package logica.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;


public class TxTButtonMenu
extends Container
{		
	
	private ActionListener actionListener;
	
	private int itemNr = 0;
	private int active = 0;
	
	private int w = 0;
	private int h = 0;
	
	private int margin = 2;
	private int buffersize = 10;
	
	private TxTButton[] item = new TxTButton[buffersize];
	
	
	public TxTButtonMenu()
	{
		super();
	}
	
	public void addItem(String name)
	{	
		item[itemNr] = new TxTButton(name,itemNr);
		item[itemNr].addActionListener(new ItemActionListener() );
		itemNr++;
		if (itemNr >= buffersize) 
		{
			buffersize += 10;
			TxTButton[] temp = new TxTButton[buffersize];
			System.arraycopy(item,0,temp,0,item.length);
			item = temp;
		}
		arrange();		
	}
	
	public void removeAllItems(int nr)
	{
		itemNr = 0;
		arrange();
	}
	
	public void arrange()
	{
		removeAll();
		setLayout(null);
		w = 0;
		h = itemNr * item[0].getHeight() + margin + 10;
		
		for(int i=0;i<itemNr;i++)
		{
			w = Math.max(item[i].getWidth(),w);
			
		}
		
		for(int i=0;i<itemNr;i++)
		{
			item[i].setWidth(w);
			item[i].setLocation(0,i * item[i].getHeight() + margin);			
			add(item[i]);
		}				
		setSize(w,h);
		item[active].setActive(true);

		// Fr unser Null-Layout wahrscheinlich nicht notwendig aber trotzdem		
		invalidate();
		doLayout();		
		Container owner = getParent();
		if (owner != null) 
		{
			owner.invalidate();
			owner.doLayout();
		}		
	}
	
	public int getHeight()
	{
		return h;
	}
	
	public int getWidth()
	{
		return w;
	}
	 
	public void addActionListener(ActionListener listener)
	{
		actionListener = AWTEventMulticaster.add(actionListener, listener);
		enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	}
		
	public void removeActionListener(ActionListener listener)
	{
		actionListener = AWTEventMulticaster.remove(actionListener, listener);
	}			
	
	
	
	
	class ItemActionListener
	implements ActionListener
	{
		public void actionPerformed(ActionEvent e) 
		{
			TxTButton src = ((TxTButton)e.getSource());
			
			if (item[src.getId()].getActive() == false) 
			{
				item[active].setActive(false);
				item[src.getId()].setActive(true);
				active = src.getId();
				if(actionListener != null) 
				{
					actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, e.getActionCommand()));				
				}	
			}				
		 }
	}
}



