package logica.gui;


import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class WorldMap 
extends MapVisualization
{
	
	private static float MAX_AREA_RATIO = 0.28F;
	private float max_area;
		
	private MapElement[] region = new RegionSquare[buffersize];
	
        
	public WorldMap(int width, int height)
	{		
		super(width,height);		
				
		max_area = MAX_AREA_RATIO * h * w;			
	}
	
	public void paint(Graphics g)
	{
		//g.setColor(Color.black);
		//g.fillRect(0,0,w,h);
		super.paint(g);
	}
	
	
	public void addRegion(String name, int id, float x, float y, float value)
	{
		int offset = 25;
		region[nrOfRegions] = new RegionSquare(name, 
							id, 
							w/2 + (x/360 * w), 
							h/2 + (y/180 * h) + offset, 
							value);		
		region[nrOfRegions].addMouseListener(this);
		nrOfRegions++;
		if (nrOfRegions >= buffersize) 
		{
			buffersize += 10;
			MapElement[] temp = new RegionSquare[buffersize];
			System.arraycopy(region,0,temp,0,region.length);
			region = temp;
		}		
	}
	
	
	        
	void arrange()
	{
		removeAll();
		
		setLayout(null);
		setSize(w,h);
		
		add(regionLabel);
		
		sortByValue(region);
		scaleToFit(region,4.0F,max_area);
		
		for(int i = 0; i < nrOfRegions; ++i)
		{
			add(region[i]);					
		}		
		repaint();
	}
	
	public void reArrange()
	{
		arrange();
	}
	
	
	public void setNewData(float[] values)
	{
		sortById(region);
		for (int i = 0; i < nrOfRegions; ++i) 
		{		
			if (i < values.length) {
				region[i].setValue(values[i]);
				region[i].setAbsValue(values[i]);
			}
			else {
				region[i].setValue(0);								// ist der array zu kurz wert auf null setzen
				region[i].setAbsValue(0);							// ueberschuessige elemnte zu langer array werden ignoriert
			}
		}
		arrange();
	}
			

	public void activate(int id)
	{
		for (int i = 0; i < nrOfRegions; i++)
		{
			if (region[i].getActive()) region[i].setActive(false);
			if (region[i].getId() == id) region[i].setActive(true);
		}
	}
	
	void scaleToFit(MapElement[] object, float min, float max)
	{
        	float sum = 0.0F;        
        
	        for (int i=0; i < nrOfRegions; i++)
        	{
	            sum += Math.max(0,object[i].getValue());
        	}  
               
        
	        for (int i=0; i < nrOfRegions; i++)
        	{
            		object[i].setValue(object[i].getValue() / sum * max );
			if (object[i].getValue() < min) object[i].setValue(min);
		}    
	}	
}
    

    
    
     
     
     
     

