package logica.sim;

import logica.utility.*;
import logica.sim.data.*;


public class Calc {
	private Year[] yr;
	private Vars v;
	
	public Utility u;
	
	int regNrOfFoodNeedReg[];
	
	
	//020312 - saving memory
	SimData s;
	WorldData w;
	WorldData wPrevYr;
	RegionData r;
	RegionData rBaseYr;
	RegionData rPrevYr;
	RegionData rPrevYr2;
	RegionData rPrevYr3;
	RegionData rPrevYr4;
	
	Runtime rt;
	
	
	//DEBUG
	long oldMem = 0;
	public long memDiff(String text) {
		//		long mem = Runtime.getRuntime().freeMemory();
		long mem = rt.freeMemory();
		long diff = oldMem - mem;
		oldMem = mem;
		System.out.println(text + " " + mem + " " + diff);
		return diff;
	}
	
	
	public Calc(Year[] yrArg, Vars vArg, Utility uArg) {
		yr = yrArg;
		v = vArg;
		u = uArg;
		
		rt = Runtime.getRuntime();
	}
	
	
	boolean hadNaN = false;
	String[] siAnsa;
	public void debugMsg(int type, int methNr, String textArg) {
		//		if (((methNr < 129) | (methNr > 140)) & (methNr != 113) & (methNr != 147)) memDiff(textArg);
		//		u.addMsg(type, v.calcYr + " " + textArg);
		//		u.addYr(methNr, yr[v.calcYr], textArg);
// NaN-Test without Plotter.java
//		if ((v.calcYr > 38) &
//		(v.calcYr < 42) &
//		((methNr < 127) | (methNr > 141)) &
//		(methNr != 113) &
//		(methNr != 147) &
//		(!hadNaN)) {
//			System.out.println("suche NaN in jahr " + v.calcYr);
//			for (int i = 0; i < v.numRegs; i++) {
//				if (!hadNaN) {
//					siAnsa = yr[v.calcYr].r[i].getNaN();
//					if (siAnsa.length > 0) {
//						System.out.println("NaN oder Infinity");
//						System.out.println("Region " + i + "   " + methNr);
//						for (int j = 0; j < siAnsa.length; j++) {
//							try {
//								System.out.println(siAnsa[j] + " = " + yr[v.calcYr].r[i].getValueRefl(siAnsa[j]));
//							} catch (Exception e) {
//								System.out.println("bla");
//							}
//						}
//						hadNaN = true;
//						//return;
//					}
//				}
//			}
//		}
	}
	
	
	public void initRegions() {
		debugMsg(2, 101, "initRegions");
		
		s = yr[v.calcYr].s;
		w = yr[v.calcYr].w;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rBaseYr = yr[v.baseYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			rPrevYr2 = yr[v.calcYr - 2].r[i];
			rPrevYr3 = yr[v.calcYr - 3].r[i];
			
			r.industBase_stat = r.util_investS_indust * r.util_tni;
			r.agriEquip_stat = r.util_investS_agri * r.util_tni;
			r.advTech_stat = r.util_investS_advTech * r.util_tni;
			r.other_stat = r.util_investS_other * r.util_tni;
			
			r.pop_inAgri2Pop = r.pop_inAgri / r.pop_stat;
			r.educ_manHourTrainCum = r.educ_manHourTrainCap * r.pop_stat;
			r.nonrenew_stat = r.nonrenew_fact * r.area;
			r.util_gain = r.pop_stat;
			r.util_industExp= r.util_investS_exp * r.util_tni;
			
			w.area += r.area;
			w.popStat += r.pop_stat;
			w.manHourTrainCum += r.educ_manHourTrainCum;
			w.industBase_stat += r.industBase_stat;
			w.indust_exp += r.util_industExp;
			w.nonrenew_stat += r.nonrenew_stat;
			w.advTech_stat += r.advTech_stat;
			
			//BUGFIX 020207
			r.pop_statBY = rBaseYr.pop_stat;
			r.pop_inAgriBY = r.pop_inAgri;
			r.food_prodBY = r.food_calPerCapDayBY * r.pop_statBY * s.cal2TonConvC;
			r.food_prodGrowth = 1.0F;
			r.util_tniBY = r.util_tni;
			r.agriEquip_statBY = r.agriEquip_stat;
			
			
			rPrevYr.food_surplus = r.food_surplus;
			rPrevYr.pop_stat = r.pop_stat;
			//BUGFIX 020203
			rPrevYr2.pop_stat = r.pop_stat;
			
			//BUGFIX 020207
			r.nonrenew_throughput = 1.0F;
			rPrevYr.nonrenew_throughput = 1.0F;
			r.nonrenew_dmd = 1.0F;
			rPrevYr.nonrenew_dmd = 1.0F;
			r.econ_strenClass = 4;
			rPrevYr.econ_strenClass = 4;
			r.indust_delayedIdleFrac = 0.16F;
			r.oil_prod = 0.0F;
			r.oil_extractTotal = 0.0F;
			r.oil_typeChangeH = 0.0F;
			r.oil_supply2Dmd = 1.0F;
			r.oil_consum2Dmd = 1.0F;
			r.coal_supply2Dmd = 1.0F;
			r.agri_oilSatMult = 1.0F;
			r.oil_found = 0.0F;
			rPrevYr.oil_found = 0.0F;
			rPrevYr2.oil_found = 0.0F;
			rPrevYr3.oil_found = 0.0F;
			r.indust_idleFrac = 0.16F;
			rPrevYr.indust_idleFrac = 0.16F;
			rPrevYr2.indust_idleFrac = 0.16F;
			rPrevYr3.indust_idleFrac = 0.16F;
			
			//rw3L - code for user-input; sepp 020313
			r.food_surp2Aid = s.foodSurp2Aid;
			r.util_avail2Aid = s.util2AidFract;
		}
	}
	
	
	public void worldSetVarsA() {
		debugMsg(2, 102, "worldSetVarsA");
		w = yr[v.calcYr].w;
		
		w.manHourTrainCap = w.manHourTrainCum / w.popStat;
		w.nonrenew_fact = w.nonrenew_stat / w.area;
	}
	
	
	public void regClassTechTrain() {
		debugMsg(2, 103, "regClassTechTrain");
		
		w = yr[v.calcYr].w;
		
		//BUGFIX 020214
		w.food_surp = 0.0F;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			//00002790 - 00002830
			//BUGFIX 020211
			r.econ_strenClass = 0;
			if (r.util_avail > 0) r.econ_strenClass = 1;
			if (r.util_avail > (rPrevYr.pop_stat * 10.0F)) r.econ_strenClass = 2;
			
			//00002870 - 00002910
			//Tech
			float industRatioT = (r.industBase_stat / rPrevYr.pop_stat) /
			(w.industBase_stat / w.popStat);
			//BUGFIX 020207
			r.indust_ratio = Math.min(industRatioT, 1.25F);
			r.indust_ratio = Math.max(r.indust_ratio, 0.1F);
			r.tech_ratio = 5.0F * r.advTech_stat / (r.industBase_stat + 5.0F * r.advTech_stat);
			
			//BUGFIX 020403
			r.tech_ratio = deNaN(r.tech_ratio);
			
			r.tech_stat = 0.3F + 0.4F * r.tech_ratio - 0.2F * r.pop_inAgri2Pop + 0.32F * r.indust_ratio;
			
			//00002950 - 00003000
			//Training Level
			float trainingLevelT = Math.min((r.educ_manHourTrainCap / w.manHourTrainCap), 2.0F);
			r.educ_effic = 0.4F + 0.3F * r.tech_ratio + 0.2F * trainingLevelT - 0.1F * r.pop_inAgri2Pop;
			r.food_delivMult = 0.5F + 0.5F * r.educ_effic;
		}
	}
	
	
	public void regPrevIndustProdFYR() {
		debugMsg(2, 104, "regPrevIndustProdFYR");
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			r.tech_statBY = r.tech_stat;
			rPrevYr.indust_prod = r.educ_effic * r.industBase_stat;
		}
	}
	
	
	public void regFoodGrowthCalcA() {
		debugMsg(2, 105, "regFoodGrowthCalcA");
		
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			
			r.food_prodGrowthCalc = r.pop_inAgri2Pop * r.pop_inAgri / r.pop_inAgriBY
			+ ( (1.0F - s.oilUse_agri[r.oil_type] * r.coal_supply2Dmd
			+ s.oilUse_agri[r.oil_type] * r.agri_oilSatMult)
			* (r.agriEquip_stat / r.agriEquip_statBY) )
			* (1.0F - r.pop_inAgri2Pop) * 0.8F
			+ Math.min((r.tech_stat/r.tech_statBY),1.18F)
			* (1.0F - r.pop_inAgri2Pop) * 0.2F;
			
			//BUGFIX 020403
			r.food_prodGrowthCalc = deNaN(r.food_prodGrowthCalc);
		}
	}
	
	
	public void regFoodGrowthCalcB() {
		debugMsg(2, 106, "regFoodGrowthCalcB");
		
		w = yr[v.calcYr].w;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			
			if (r.food_exp > 0.0F)
				r.food_prodGrowthCalc += 0.1F * (w.food_price - 70) / w.food_price;
			
			r.food_prodGrowth *= (1.0 + r.food_prodGrowthBY / 200.0F);
		}
	}
	
	
	public void regFood() {
		debugMsg(2, 107, "regFood");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			r.food_prod = Math.min(r.food_prodGrowth, r.food_prodGrowthCalc) * r.food_prodBY;
			
			r.food_calPerCapDay = (r.food_prod / rPrevYr.pop_stat) * s.grain2CalC;
			
			if (r.food_calPerCapDay > (3.0F * r.food_calPerCapDayNeed)) r.econ_strenClass++;
			
			//grain demand is different for poor and rich countries
			//dependent on CONSK and COTH, which are read in
			float grainDmdT;			//TGDEM
			if (rPrevYr.econ_strenClass <= 2)
				grainDmdT = r.food_calPerCapDayNeed * rPrevYr.pop_stat * s.cal2TonConvC;
			else {
				float conservT = 1.0F;
				if (r.conservFlag & (r.econ_incomePerCap > s.conservMult * w.medianIncome))
					conservT = s.conservFraction;
				grainDmdT = r.food_calPerCapDayNeed
				* (1.0F + 0.14815F * conservT * (r.food_calPerCapDayNeed / 2700.0F)
				* Math.min(rPrevYr.econ_strenClass, 6))
				* rPrevYr.pop_stat * s.cal2TonConvC;
			}
			
			if (rPrevYr.food_surplus > 10.0E6) r.econ_strenClass++;
			
			//calculating food demand or surplus
			r.food_prod2Need = r.food_prod - grainDmdT;
			if (grainDmdT > r.food_prod) {
				if (rPrevYr.food_surplus + r.food_prod2Need <= 0) {
					r.food_dmd = - r.food_prod2Need - rPrevYr.food_surplus;
					r.food_surplus = 0;
				}
				else {
					r.food_dmd = 0;
					r.food_surplus = rPrevYr.food_surplus + r.food_prod2Need;
				}
			}
			else {
				r.food_dmd = 0;
				r.food_surplus = rPrevYr.food_surplus + r.food_prod2Need;
				w.food_surp += 0.9F * r.food_surplus;
			}
		}
	}
	
	
	public void regEmigImmigReset() {
		debugMsg(2, 108, "regEmigImmigReset");
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			
			r.pop_emigr = 0.0F;
			r.pop_immigr = 0.0F;
		}
	}
	
	
	
	public void worldFoodSurpSetFYR() {
		debugMsg(2, 109, "worldFoodSurpSetFYR");
		
		yr[v.calcYr - 1].w.food_surp = yr[v.calcYr].w.food_surp;
	}
	
	
	public void regGNPFYR() {
		debugMsg(2, 110, "regGNPFYR");
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			r.econ_gnp = 0.5F * r.industBase_stat;
			r.econ_incomePerCap = r.econ_gnp / rPrevYr.pop_stat;
		}
	}
	
	
	public void regGNP() {
		debugMsg(2, 111, "regGNP");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			r.econ_gnp = rPrevYr.indust_prod + r.food_prod * w.food_price
			+ r.util_coalExp + r.util_nonrenewExp + r.util_oilExp;
			
			if ((w.util_aidAvail <= s.utilAidMax)
			& (r.util_avail > s.utilAidQualifierC * r.econ_gnp)
			& (r.rankByIncome <= v.regMedC)) {
				
				//rw3L - added User Input
				// sepp 020313
				r.util_avail -= r.util_avail2Aid * r.util_avail;
				// NaN-safe:
				if (r.util_avail == 0.0F) r.util_avail = 0.1F;
				w.util_aidAvail += r.util_avail2Aid * r.util_avail;
				//				r.util_avail -= s.util2AidFract * r.util_avail;
				//				w.util_aidAvail += s.util2AidFract * r.util_avail;
			}
			
			r.econ_incomePerCap = r.econ_gnp / rPrevYr.pop_stat;
		}
	}
	
	
	public void regRankByIncome() {
		debugMsg(2, 112, "regRankByIncome");
		
		//		rw3-original code
		//		int rankT;
		//		for (int i = 0; i < v.numRegs; i++) {
		//			rankT = 0;
		//			for (int j = 0; j < v.numRegs; j++) {
		//				if (yr[v.calcYr].r[j].econ_incomePerCap > yr[v.calcYr].r[i].econ_incomePerCap)
		//					rankT++;
		//			}
		//			yr[v.calcYr].r[i].rankByIncome = rankT;
		//		}
		
		//		sepp 020314; improved sorting mechanism
		float[] vals = new float[v.numRegs];
		for (int i = 0; i < v.numRegs; i++) {
			vals[i] = yr[v.calcYr].r[i].econ_incomePerCap;
		}
		int[] result = sortMe(vals);
		
		for (int i = 0; i < v.numRegs; i++) {
			yr[v.calcYr].r[i].rankByIncome = result[i];
		}
	}
	
	
	public int regNrOfEconRanked(int rank) {
		for (int i = 0; i < v.numRegs; i++) {
			if (yr[v.calcYr].r[i].rankByIncome == rank) {
				//debugMsg(3, 113, "regNrOfEconRanked(" + rank + ") " + yr[v.calcYr].r[i].name);
				return i;
			}
		}
		
		debugMsg(3, 113, "regNrOfEconRanked(" + rank + ") Fehler!");
		return 0;
	}
	
	
	public void regUtilAid() {
		debugMsg(2, 114, "regUtilAid");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		//CHANGED 020203
		w.util_need = 1.0E-10F;
		
		//who needs...
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			r.util_need = 0.0F;
			
			if(r.util_avail <= 0.0F) {
				float utilAidNutT = s.utilAidNeed2NutC
				* Math.max((0.8F - r.pop_nutLvl), 0.0F);
				float utilAidIncT = s.utilAidNeed2IncomeC
				* Math.max((100.0F - r.econ_incomePerCap), 0.0F);
				float utilAidT = (utilAidNutT + utilAidIncT) * rPrevYr.pop_stat;
				
				r.util_need = utilAidT;
				
				if(utilAidT > s.utilAidNeedMin)
					w.util_need += utilAidT;
			}
		}
		
		float utilAidFracT = Math.min(1.0F, Math.max(0.001F, (w.util_aidAvail / w.util_need)));
		
		//and who gets
		for (int i = v.numRegs - 1; i > (v.numRegs - 1) - s.utilAidRegsMax; i--) {
			r = yr[v.calcYr].r[regNrOfEconRanked(i)];
			
			float utilAidT = utilAidFracT * r.util_need;
			
			w.util_aidAvail -= utilAidT;
			r.util_avail += utilAidT;
			
			if (w.util_aidAvail < 0.0F) w.util_aidAvail = 0.0F;
		}
	}
	
	
	public void worldResetImpExp() {
		debugMsg(2, 115, "worldResetImpExp");
		
		w = yr[v.calcYr].w;
		
		w.food_dmd = 0.0F;
		w.coal_impDmd = 0.0F;
		w.coal_expAvail = 0.0F;
		w.oil_impDmd = 0.0F;
		w.oil_expAvail = 0.0F;
		w.nonrenew_exp = 0.0F;
	}
	
	
	public void regClassCoalDmdNProd() {
		debugMsg(2, 116, "regClassCoalDmdNProd");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			//economic growth
			r.investPerCap2BY = (r.util_tni / r.util_tniBY)
			- (rPrevYr.pop_stat / r.pop_statBY);
			
			//BUGFIX 020403
			r.investPerCap2BY = deNaN(r.investPerCap2BY);
			
			if (r.investPerCap2BY > 0.0F) r.econ_strenClass++;
			
			//utils available for food import
			r.util_availImp = r.util_avail + 0.5F * rPrevYr.indust_prod + r.util_gain;
			
			if (r.util_availImp < 0.0F) r.util_availImp = 0.0F;
			if (r.util_availImp > s.utilForFoodMin) w.food_dmd += r.food_dmd;
			
			//classification
			float world2RegPopT = w.popStat / rPrevYr.pop_stat;
			if ((world2RegPopT * (r.advTech_stat / w.advTech_stat)) >= 2) r.econ_strenClass++;
			if ((r.util_industExp- r.indust_imp) > (0.5F * rPrevYr.pop_stat)) r.econ_strenClass++;
			if (r.econ_incomePerCap > (6.0F * w.food_price)) r.econ_strenClass++;
			
			//coal
			float sumT = s.energy_indust * r.util_investS_indust
			* s.coalUseC * (1.0F - s.oilUse_indust[r.oil_type])
			+ s.energy_agri * r.util_investS_agri
			* s.coalUseC * (1.0F - s.oilUse_agri[r.oil_type])
			+ s.energy_advTech * r.util_investS_advTech
			* s.coalUseC * (1.0F - s.oilUse_advTech[r.oil_type])
			+ s.energy_other * r.util_investS_other
			* s.coalUseC * (1.0F - s.oilUse_other[r.oil_type]);
			r.coal_dmd = sumT * r.util_tni;
			r.coal_prod = Math.min(r.coal_dmd, s.coalMinedPerYr * r.coal_resource);
			r.coal_impDmd = r.coal_dmd - r.coal_prod;
			//export or import
			if (r.coal_impDmd <= 0.0F) {
				r.coal_impDmd = 0.0F;
				r.coal_expAvail = (0.002F * (11 - rPrevYr.econ_strenClass) * r.coal_resource)
				- r.coal_prod;
				if (r.coal_expAvail > Math.min((0.5F * rPrevYr.pop_stat), s.coalExpMax)) {
					w.coal_expAvail += r.coal_expAvail;
					r.econ_strenClass++;
				}
				else r.coal_expAvail = 0.0F;
			}
			else {
				w.coal_impDmd += r.coal_impDmd;
				r.coal_expAvail = 0.0F;
			}
		}
	}
	
	
	public void regNonrenew() {
		debugMsg(2, 117, "regNonrenew");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			r.nonrenew_dmd = 0.015F * rPrevYr.indust_prod;
			r.nonrenew_recycled = 0.5F * r.nonrenew_dmd
			* (0.5F * r.tech_stat + 0.5F * r.educ_effic);
			r.nonrenew_consum = Math.min(r.nonrenew_dmd - r.nonrenew_recycled,
			s.nonrenewMinedPerYr * r.nonrenew_stat);
			r.nonrenew_dmdRemain = r.nonrenew_dmd - r.nonrenew_recycled - r.nonrenew_consum;
			r.nonrenew_expPressure = 1.4F - 0.14F * rPrevYr.econ_strenClass;
			
			if (r.nonrenew_expPressure < 0.1F) r.nonrenew_expPressure = 0.0F;
			if (r.pop_nutLvl < 0.85F) r.nonrenew_expPressure = 1.0F;
			
			r.nonrenew_expSurp = (r.nonrenew_fact / w.nonrenew_fact) * r.nonrenew_stat;
			
			float expLimT = Math.min((0.5F * rPrevYr.pop_stat), s.nonrenewExpMax);
			if (r.nonrenew_expSurp > expLimT) r.econ_strenClass++;
			if (r.nonrenew_expSurp < expLimT) r.nonrenew_expSurp = 0.0F;
			
			r.nonrenew_expSurp = Math.min(Math.max(0.0F, r.nonrenew_expSurp),
			Math.max(0.0F, s.nonrenewMinedPerYr * r.nonrenew_stat
			- r.nonrenew_consum))
			* r.nonrenew_expPressure;
			
			w.nonrenew_exp += r.nonrenew_expSurp;
		}
	}
	
	
	public void regOil() {
		debugMsg(2, 118, "regOil");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			rPrevYr4 = yr[v.calcYr - 4].r[i];
			
			r.oil_proven += rPrevYr4.oil_found - r.oil_prod;
			r.oil_extractTotal += r.oil_prod;
			r.oil_found = 0.1F * (r.oil_totalReserves - r.oil_extractTotal - r.oil_proven)
			/ r.oil_extrDiffFactor;
			
			r.oil_dmdCoeffS_indust = s.energy_indust * s.oilUseC * s.oilUse_indust[r.oil_type]
			* r.util_investS_indust;
			r.oil_dmdCoeffS_agri = s.energy_agri * s.oilUseC * s.oilUse_agri[r.oil_type]
			* r.util_investS_agri;
			r.oil_dmdCoeffS_advTech = s.energy_advTech * s.oilUseC * s.oilUse_advTech[r.oil_type]
			* r.util_investS_advTech;
			r.oil_dmdCoeffS_other = s.energy_other * s.oilUseC * s.oilUse_other[r.oil_type]
			* r.util_investS_other;
			
			if (r.conservFlag & (r.econ_incomePerCap > s.conservMult * w.medianIncome))
				r.oil_dmdCoeffS_other *= s.conservFraction;
			
			float dmdSumT = r.oil_dmdCoeffS_indust + r.oil_dmdCoeffS_agri
			+ r.oil_dmdCoeffS_advTech + r.oil_dmdCoeffS_other;
			r.oil_dmdNS_indust = r.oil_dmdCoeffS_indust / dmdSumT;
			r.oil_dmdNS_agri = r.oil_dmdCoeffS_agri / dmdSumT;
			r.oil_dmdNS_advTech = r.oil_dmdCoeffS_advTech / dmdSumT;
			r.oil_dmdNS_other = r.oil_dmdCoeffS_other / dmdSumT;
			
			r.oil_dmd = dmdSumT * r.util_tni;
			
			r.indust_oilDmd = r.oil_dmdCoeffS_indust * r.util_tni;
			
			r.oil_domProd = Math.min(r.oil_dmd, (0.1F * r.tech_stat * r.oil_proven));
			r.oil_impDmd = Math.max((r.oil_dmd - r.oil_domProd), 0.0F);
			
			
			if (r.oil_impDmd <= 0.0F) {
				r.oil_expAvail = Math.max(0.0F,
				0.007F * (11 - rPrevYr.econ_strenClass) * r.oil_proven
				- r.oil_domProd);
				r.oil_expAvail = Math.min(r.oil_expAvail, 0.04F * r.oil_proven);
				
				if (r.oil_expAvail > Math.min(100000.0F, 0.005F * rPrevYr.pop_stat)) {
					w.oil_expAvail += r.oil_expAvail;
					r.econ_strenClass++;
				}
				else {
					r.oil_expAvail = 0.0F;
				}
			}
			else {
				w.oil_impDmd += r.oil_impDmd;
				r.oil_expAvail = 0.0F;
			}
		}
	}
	
	
	public void regSetOilFoundFYR() {
		debugMsg(2, 119, "regSetOilFoundFYR");
		
		for (int i = 0; i < v.numRegs; i++) {
			yr[v.calcYr - 1].r[i].oil_found = yr[v.calcYr].r[i].oil_found;
			yr[v.calcYr - 2].r[i].oil_found = yr[v.calcYr].r[i].oil_found;
			yr[v.calcYr - 3].r[i].oil_found = yr[v.calcYr].r[i].oil_found;
		}
	}
	
	
	public void worldPricingEtc() {
		debugMsg(2, 120, "worldPricingEtc");
		
		w = yr[v.calcYr].w;
		wPrevYr = yr[v.calcYr - 1].w;
		s = yr[v.calcYr].s;
		
		//BUGFIX 020210
		w.nonrenew_price = w.nonrenew_basePrice;
		
		if(w.oil_expAvail > 0) {
			w.oil_price = Math.min((w.oil_impDmd / w.oil_expAvail), 2.0F);
			w.oil_price = Math.max(w.oil_price, 1.0F);
			w.oil_price *= w.oil_basePrice;
		}
		else {
			w.oil_price = w.oil_basePrice;
		}
		
		if(w.coal_expAvail > 0) {
			w.coal_price = Math.min((w.coal_impDmd / w.coal_expAvail), 5.0F);
			w.coal_price = Math.max(w.coal_price, 1.0F);
			w.coal_price *= w.coal_basePrice;
		}
		else {
			w.coal_price = w.coal_basePrice;
		}
		
		if(w.food_surp > 0.0F) {
			w.food_price = (w.food_dmd / w.food_surp) * s.foodCostC;
			w.food_price = Math.min((w.food_price), 140.0F);
			w.food_price = Math.max((w.food_price), 70.0F);
		}
		else if(w.food_surp == 0.0F) {
			w.food_price = 140.0F;
		}
		
		w.indust_expAvail = 0.0F;
		w.indust_expAvailS_indust = 0.0F;
		w.indust_expAvailS_agri = 0.0F;
		w.indust_expAvailS_advTech = 0.0F;
		w.indust_expAvailS_other = 0.0F;
		w.indust_expAvailS_overhead = 0.0F;
		
		if (w.food_surp > wPrevYr.food_surp) w.food_growth = true;
		else w.food_growth = false;
	}
	
	
	//// pre-UI-version by 020316
	//
	//	public void regDemand() {
	//		debugMsg(2, 121, "regDemand");
	//
	//		w = yr[v.calcYr].w;
	//		s = yr[v.calcYr].s;
	//
	//		//ADDITION 020220
	//		float[] smoothVals = new float[5];
	//
	//		for (int i = 0; i < v.numRegs; i++) {
	//			r = yr[v.calcYr].r[i];
	//			rPrevYr = yr[v.calcYr - 1].r[i];
	//			rPrevYr2 = yr[v.calcYr - 2].r[i];
	//
	//			//industry
	//			float dmdMultT = s.decay_indust;
	//
	//			if (r.util_investS_indust > r.util_targetS_indust) dmdMultT += s.industAdd_investGTTarget;
	//			else dmdMultT += s.industAdd_investLTTarget;
	//			dmdMultT += s.industAdd_delayedIdleFrac * (0.14F - r.indust_delayedIdleFrac);			//BUGFIX 020316 (* for -)
	//			if (r.oil_consum2Dmd < 0.99F) dmdMultT += s.industAdd_consum2Dmd
	//			                                          * s.oilUse_indust[r.oil_type];
	//			if (r.agri_oilSatMult < 0.5F) dmdMultT += s.industAdd_agriOilSat
	//			                                          * s.oilUse_agri[r.oil_type];
	//			if (r.investPerCap2BY < 0.0F) dmdMultT += s.industAdd_investLoss
	//			                                          * (1.0F - 10.0F * r.investPerCap2BY);
	//			dmdMultT += ((rPrevYr.pop_stat / rPrevYr2.pop_stat) - 1.0F);
	//
	//			r.industBase_dmd = r.industBase_stat * dmdMultT;
	//			//ADDITION 020220
	//			if (v.calcYr > v.baseYr) {
	//				for (int h = -4; h <= 0; h++) smoothVals[h + 4] = yr[Math.max(v.baseYr + 1, v.calcYr + h)].r[i].industBase_dmd;
	//				r.industBase_dmd = smoothMe(smoothVals);
	//			}
	//
	//			//agriculture
	//			dmdMultT = s.decay_agri;
	//
	//			if (!w.food_growth) dmdMultT += s.agriAdd_worldFoodLoss;
	//			else if (w.food_price == 70.0F) dmdMultT += s.agriAdd_foodPriceMinimal;
	//			if (r.util_investS_agri < r.util_targetS_agri) dmdMultT += s.agriAdd_investLTTarget;
	//			//BUGFIX 020211 (* to +)
	//			if (w.food_price > 70.0F) dmdMultT += s.agriAdd_foodPriceMore * (w.food_price + 30.0F);
	//			if (r.food_surplus > rPrevYr.food_surplus) dmdMultT += s.agriAdd_surplusGrowth;
	//			if (r.investPerCap2BY < 0.0F) dmdMultT += s.agriAdd_investLoss
	//			                                          * (1.0F - 10.0F * r.investPerCap2BY);
	//			if (r.agri_oilSatMult < 1.0F) dmdMultT += s.agriAdd_oilSatDmd
	//			                                          * (r.agri_oilSatMult - 1);
	//			dmdMultT += ((rPrevYr.pop_stat / rPrevYr2.pop_stat) - 1.0F);
	//
	//			r.agriEquip_dmd = r.agriEquip_stat * dmdMultT;
	//			//ADDITION 020220
	//			if (v.calcYr > v.baseYr) {
	//				for (int h = -4; h <= 0; h++) smoothVals[h + 4] = yr[Math.max(v.baseYr + 1, v.calcYr + h)].r[i].agriEquip_dmd;
	//				r.agriEquip_dmd = smoothMe(smoothVals);
	//			}
	//
	//			//advanced technology
	//			dmdMultT = s.decay_advTech;
	//
	//			if (r.util_investS_advTech > r.util_targetS_advTech) dmdMultT += s.advTechAdd_investGTTarget;
	//			else dmdMultT += s.advTechAdd_investLTTarget;
	//			if (r.educ_manHourTrainCap > 8000.0F) dmdMultT += s.advTechAdd_manHourTrainCap;
	//			dmdMultT += s.advTechAdd_econStrenClass * rPrevYr.econ_strenClass;
	//			if (r.util_avail > 0.0F) dmdMultT += s.advTechAdd_utilAvail;
	//			if (r.pop_inAgri2Pop > 0.15F) dmdMultT+= s.advTechAdd_inAgri2Pop;
	//			if (r.investPerCap2BY < 0.0F) dmdMultT += s.agriAdd_investLoss
	//			                                          * (1.0F - 10.0F * r.investPerCap2BY);
	//
	//			r.advTech_dmd = r.advTech_stat * dmdMultT;
	//			//ADDITION 020220
	//			if (v.calcYr > v.baseYr) {
	//				for (int h = -4; h <= 0; h++) smoothVals[h + 4] = yr[Math.max(v.baseYr + 1, v.calcYr + h)].r[i].advTech_dmd;
	//				r.advTech_dmd = smoothMe(smoothVals);
	//			}
	//
	//			//other
	//			dmdMultT = s.decay_other;
	//
	//			if (r.util_investS_other > r.util_targetS_other) dmdMultT += s.otherAdd_investGTTarget;
	//			else dmdMultT += s.otherAdd_investLTTarget;
	//			if (r.pop_nutLvl >= 0.99F) dmdMultT += s.otherAdd_nutLvl;
	//			if (r.util_avail > 0.0F) dmdMultT += s.otherAdd_utilAvailPlus;
	//			else dmdMultT += s.otherAdd_utilAvailMinus;
	//			dmdMultT += s.otherAdd_econStrenClass * rPrevYr.econ_strenClass;
	//			if (r.investPerCap2BY < 0.0F) dmdMultT += s.otherAdd_investLoss
	//			                                          * (1.0F - 10.0F * r.investPerCap2BY);
	//
	//			r.other_dmd = r.other_stat * dmdMultT;
	//			//ADDITION 020220
	//			if (v.calcYr > v.baseYr) {
	//				for (int h = -4; h <= 0; h++) smoothVals[h + 4] = yr[Math.max(v.baseYr + 1, v.calcYr + h)].r[i].other_dmd;
	//				r.other_dmd = smoothMe(smoothVals);
	//			}
	//
	//			//overhead, part 1
	//			r.overhead_dmd = 0.02F * (1.0F + 0.5F * rPrevYr.econ_strenClass) * r.econ_gnp;
	//		}
	//	}
	
	
	// version with smoothed additions for better incorporation of ui;
	// sepp, 020316
	//ADDITION 020220
	float[] smoothVals = new float[5];
	public void regDemand() {
		debugMsg(2, 121, "regDemand");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			rPrevYr2 = yr[v.calcYr - 2].r[i];
			
			//industry
			float dmdMultT = s.decay_indust;
			
			//			dmdMultT += rampIt(1.0F, 1.2F, r.util_investS_indust / r.util_targetS_indust, -0.01F);
			//			dmdMultT += rampIt(1.0F, 0.8F, r.util_investS_indust / r.util_targetS_indust, 0.01F);
			dmdMultT += rampIt(1.0F, 1.2F, r.util_investS_indust / r.util_targetS_indust, -0.1F);
			dmdMultT += rampIt(1.0F, 0.8F, r.util_investS_indust / r.util_targetS_indust, 0.1F);
			
			dmdMultT += rampIt(0.99F, 0.9F, r.oil_consum2Dmd, -0.01F * s.oilUse_indust[r.oil_type]);
			dmdMultT += rampIt(0.5F, 0.4F, r.agri_oilSatMult, -0.03F * s.oilUse_agri[r.oil_type]);
			dmdMultT += rampIt(0.0F, -0.05F, r.investPerCap2BY, 0.05F * (1.0F - 10.0F * r.investPerCap2BY));
			dmdMultT += 0.1F * (0.14F - r.indust_delayedIdleFrac);			//BUGFIX 020316 (* for -)
			dmdMultT += ((rPrevYr.pop_stat / rPrevYr2.pop_stat) - 1.0F);
			
			dmdMultT = limit(dmdMultT, 0.01F, 0.3F);
			
			r.industBase_dmd = r.industBase_stat * dmdMultT;
			//ADDITION 020220
			if (v.calcYr > v.baseYr) {
				for (int h = -4; h <= 0; h++) smoothVals[h + 4] = yr[Math.max(v.baseYr + 1, v.calcYr + h)].r[i].industBase_dmd;
				r.industBase_dmd = smoothMe(smoothVals);
			}
			
			//agriculture
			dmdMultT = s.decay_agri;
			//			dmdMultT += rampIt(1.0F, 1.2F, r.util_targetS_agri / r.util_investS_agri, 0.01F);
			dmdMultT += rampIt(1.0F, 1.2F, r.util_targetS_agri / r.util_investS_agri, 0.1F);
			dmdMultT += rampIt(1.0F, 0.8F, r.util_targetS_agri / r.util_investS_agri, -0.1F);
			
			dmdMultT += rampIt(80.0F, 70.0F, w.food_price, -0.01F);
			dmdMultT += rampIt(80.0F, 100.0F, w.food_price, 0.0002F * (w.food_price + 30.0F));
			dmdMultT += rampIt(1.0F, 1.05F, r.food_surplus / Math.max(rPrevYr.food_surplus, 1.0F), -0.01F);
			dmdMultT += rampIt(1.0F, 0.8F, r.agri_oilSatMult, 0.05F * (r.agri_oilSatMult - 1.0F));
			dmdMultT += rampIt(0.0F, -0.05F, r.investPerCap2BY, 0.06F * (1.0F - 10.0F * r.investPerCap2BY));
			dmdMultT += ((rPrevYr.pop_stat / rPrevYr2.pop_stat) - 1.0F);
			if (!w.food_growth) dmdMultT += s.agriAdd_worldFoodLoss;
			
			dmdMultT = limit(dmdMultT, 0.01F, 0.3F);
			
			r.agriEquip_dmd = r.agriEquip_stat * dmdMultT;
			//ADDITION 020220
			if (v.calcYr > v.baseYr) {
				for (int h = -4; h <= 0; h++) smoothVals[h + 4] = yr[Math.max(v.baseYr + 1, v.calcYr + h)].r[i].agriEquip_dmd;
				r.agriEquip_dmd = smoothMe(smoothVals);
			}
			
			//advanced technology
			dmdMultT = s.decay_advTech;
			
			//			dmdMultT += rampIt(1.0F, 1.2F, r.util_targetS_advTech / r.util_investS_advTech, 0.05F);
			//			dmdMultT += rampIt(1.0F, 0.8F, r.util_targetS_advTech / r.util_investS_advTech, -0.02F);
			dmdMultT += rampIt(1.0F, 1.2F, r.util_targetS_advTech / r.util_investS_advTech, 0.5F);
			dmdMultT += rampIt(1.0F, 0.8F, r.util_targetS_advTech / r.util_investS_advTech, -0.2F);
			
			dmdMultT += rampIt(7000.0F, 9000.0F, r.educ_manHourTrainCap, 0.04F);
			dmdMultT += rampIt(0.0F, 0.05F * r.econ_gnp, r.util_avail, 0.04F);
			dmdMultT += rampIt(0.1F, 0.2F, r.pop_inAgri2Pop, -0.02F);
			dmdMultT += rampIt(0.0F, -0.05F, r.investPerCap2BY, 0.04F * (1.0F - 10.0F * r.investPerCap2BY));
			dmdMultT += 0.02F * rPrevYr.econ_strenClass;
			
			dmdMultT = limit(dmdMultT, 0.01F, 0.3F);
			
			r.advTech_dmd = r.advTech_stat * dmdMultT;
			//ADDITION 020220
			if (v.calcYr > v.baseYr) {
				for (int h = -4; h <= 0; h++) smoothVals[h + 4] = yr[Math.max(v.baseYr + 1, v.calcYr + h)].r[i].advTech_dmd;
				r.advTech_dmd = smoothMe(smoothVals);
			}
			
			//other
			dmdMultT = s.decay_other;
			
			//			dmdMultT += rampIt(1.0F, 1.2F, r.util_targetS_other / r.util_investS_other, 0.03F);
			//			dmdMultT += rampIt(1.0F, 0.8F, r.util_targetS_other / r.util_investS_other, -0.05F);
			dmdMultT += rampIt(1.0F, 1.2F, r.util_targetS_other / r.util_investS_other, 0.3F);
			dmdMultT += rampIt(1.0F, 0.8F, r.util_targetS_other / r.util_investS_other, -0.5F);
			
			dmdMultT += rampIt(0.95F, 1.05F, r.pop_nutLvl, 0.01F);
			dmdMultT += rampIt(0.0F, 0.05F * r.econ_gnp, r.util_avail, 0.02F);
			dmdMultT += rampIt(0.0F, -0.05F * r.econ_gnp, r.util_avail, -0.02F);
			dmdMultT += rampIt(0.0F, -0.05F, r.investPerCap2BY, 0.04F * (1.0F - 10.0F * r.investPerCap2BY));
			dmdMultT += 0.002F * rPrevYr.econ_strenClass;
			
			dmdMultT = limit(dmdMultT, 0.01F, 0.3F);
			
			r.other_dmd = r.other_stat * dmdMultT;
			//ADDITION 020220
			if (v.calcYr > v.baseYr) {
				for (int h = -4; h <= 0; h++) smoothVals[h + 4] = yr[Math.max(v.baseYr + 1, v.calcYr + h)].r[i].other_dmd;
				r.other_dmd = smoothMe(smoothVals);
			}
			
			//overhead, part 1
			r.overhead_dmd = 0.02F * (1.0F + 0.5F * rPrevYr.econ_strenClass) * r.econ_gnp;
		}
	}
	
	
	public float rampIt(float minLimit, float maxLimit, float compValue, float amount) {
		compValue = deNaN(compValue);
		if (minLimit < maxLimit) {
			if (compValue < minLimit) return 0.0F;
			else if (compValue > maxLimit) return amount;
			else return (((compValue - minLimit) / (maxLimit - minLimit)) * amount);
		}
		else {
			if (compValue > minLimit) return 0.0F;
			else if (compValue < maxLimit) return amount;
			else return (((minLimit - compValue) / (minLimit - maxLimit)) * amount);
		}
	}
	
	
	public void regOverheadDemand() {
		debugMsg(2, 122, "regOverheadDemand");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		//float[] smoothVals = new float[5];
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			rPrevYr2 = yr[v.calcYr - 2].r[i];
			
			//overhead, part 2
			float dmdMultT = 1.0F;
			if (r.util_avail > 0.0F) dmdMultT += s.overheadAdd_utilAvailPlus;
			if (r.util_avail < 0.0F) dmdMultT += s.overheadAdd_utilAvailMinus;
			if (r.pop_nutLvl > 0.99F) dmdMultT += s.overheadAdd_nutLvlGood;
			if (r.pop_nutLvl < 0.7F) dmdMultT += s.overheadAdd_nutLvlBad;
			if (r.agri_oilSatMult < 0.7F) dmdMultT += s.overheadAdd_oilSatDmd;
			if ((!r.conservFlag) & (r.econ_incomePerCap > s.conservMult * w.medianIncome))
				dmdMultT += s.overheadAdd_goodIncome;
			dmdMultT += ((rPrevYr.pop_stat / rPrevYr2.pop_stat) - 1.0F);
			
			//BUGFIX 020430
			dmdMultT = limit(dmdMultT, 0.01F, 0.3F);
			
			r.overhead_dmd *= dmdMultT;
			
			//ADDITION 020220
			if (v.calcYr > v.baseYr) {
				for (int h = -4; h <= 0; h++) smoothVals[h + 4] = yr[Math.max(v.baseYr + 1, v.calcYr + h)].r[i].overhead_dmd;
				r.overhead_dmd = smoothMe(smoothVals);
			}
		}
	}
	
	
	public void regProdDistribution() {
		debugMsg(2, 123, "regProdDistribution");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			float satT = r.oil_consum2Dmd * s.oilUse_indust[r.oil_type]
			+ r.coal_supply2Dmd * (1.0F - s.oilUse_indust[r.oil_type]);
			r.econ_throughputFact = Math.min((rPrevYr.nonrenew_throughput / rPrevYr.nonrenew_dmd), satT);
			r.econ_throughputFact = Math.min(r.econ_throughputFact, 1.0F);
			if (r.econ_throughputFact > 1.0F)
				r.econ_throughputFact = 0.2F + 0.8F * r.econ_throughputFact;
			
			if ((r.agri_oilSatMult >= 0.8F)
			& (w.food_price >= 100.0F)
			& (r.util_targetS_other >= 0.01F)) {
				r.util_targetS_agri += 0.004F;
				r.util_targetS_other -= 0.004F;
			}
			
			float addonT;
			int yearT = v.calcYr - v.baseYr;
			if (r.investPerCap2BY > 0.0F) {
				if (r.investPerCap2BY >= 0.02F * yearT) addonT = 0.005F * (rPrevYr.econ_strenClass - 7);
				else addonT = 0.002F * rPrevYr.econ_strenClass;
			}
			else if (r.investPerCap2BY == 0.0F) addonT = 0.0F;
			else {
				if (r.investPerCap2BY < -0.01F * yearT) addonT = 0.006F * rPrevYr.econ_strenClass;
				else addonT = 0.004F * rPrevYr.econ_strenClass;
			}
			
			float pMultIndT = 1.12F - r.indust_delayedIdleFrac + addonT;
			float pMultT = 0.9F + r.indust_delayedIdleFrac + addonT;
			
			float industExpFracT = (r.util_industExp/ rPrevYr.indust_prod)
			+ 0.1F * (r.indust_delayedIdleFrac - 0.12F);
			if (r.util_avail < 0.0F) industExpFracT += 0.01F;
			
			r.econ_distS_indust =   deNaN(pMultIndT * (r.industBase_dmd / rPrevYr.indust_prod));
			r.econ_distS_agri =     deNaN(pMultT * (r.agriEquip_dmd / rPrevYr.indust_prod));
			r.econ_distS_advTech =  deNaN(Math.min(pMultT * (r.advTech_dmd / rPrevYr.indust_prod),
			(1.5F * r.util_investS_advTech)));
			r.econ_distS_other =    deNaN(pMultT * (r.other_dmd / rPrevYr.indust_prod));
			r.econ_distS_overhead = deNaN(r.overhead_dmd / rPrevYr.indust_prod);
			r.econ_distS_exp =      deNaN(Math.max(r.util_investS_exp, industExpFracT));
			
			r.econ_distSum = r.econ_distS_indust
			+ r.econ_distS_agri
			+ r.econ_distS_advTech
			+ r.econ_distS_other
			+ r.econ_distS_overhead
			+ r.econ_distS_exp;
			r.econ_distSum += rPrevYr.indust_idleFrac;

			
			//normalize
			if (r.econ_distSum > 1.0F) {
				r.econ_distS_indust /= r.econ_distSum;
				r.econ_distS_agri /= r.econ_distSum;
				r.econ_distS_advTech /= r.econ_distSum;
				r.econ_distS_other /= r.econ_distSum;
				r.econ_distS_overhead /= r.econ_distSum;
				r.econ_distS_exp /= r.econ_distSum;
			}
		}
	}
	
	
	public void regImpDmd() {
		debugMsg(2, 124, "regImpDmd");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			
			//BUGFIX 020211 (wrong bracket settings)
			r.imp_dmdS_indust = Math.max(((r.industBase_dmd
			- r.econ_distS_indust * rPrevYr.indust_prod)
			* r.imp_possS_indust),
			0.0F);
			r.imp_dmdS_agri = Math.max(((r.agriEquip_dmd
			- r.econ_distS_agri * rPrevYr.indust_prod)
			* r.imp_possS_agri),
			0.0F);
			r.imp_dmdS_advTech = Math.max(((r.advTech_dmd
			- r.econ_distS_advTech * rPrevYr.indust_prod)
			* r.imp_possS_advTech),
			0.0F);
			r.imp_dmdS_other = Math.max(((r.other_dmd
			- r.econ_distS_other * rPrevYr.indust_prod)
			* r.imp_possS_other),
			0.0F);
			float subtrT = 1.0F;
			if (r.util_avail < 0.0F) subtrT = 1.0F + r.util_avail / r.econ_gnp;
			r.imp_dmdS_overhead = Math.max((r.overhead_dmd * subtrT
			- r.econ_distS_overhead * rPrevYr.indust_prod),
			0.0F);
			
			
			r.imp_dmd = r.imp_dmdS_indust
			+ r.imp_dmdS_agri
			+ r.imp_dmdS_advTech
			+ r.imp_dmdS_other
			+ r.imp_dmdS_overhead;
		}
	}
	
	
	public void regExpAvailAFYR() {
		debugMsg(2, 125, "regExpAvailAFYR");
		
		float sumOfInvest;
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			
			sumOfInvest = (r.util_investS_overhead + 1.0F);
			
			r.exp_coeffS_indust = r.util_investS_indust / sumOfInvest;
			r.exp_coeffS_agri = r.util_investS_agri / sumOfInvest;
			r.exp_coeffS_advTech = r.util_investS_advTech / sumOfInvest;
			r.exp_coeffS_other = r.util_investS_other / sumOfInvest;
			r.exp_coeffS_overhead = r.util_investS_overhead / sumOfInvest;
		}
	}
	
	
	public void regExpAvailA() {
		debugMsg(2, 126, "regExpAvailA");
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			
			
			//FIX 020207
			r.util_industExp= Math.max(r.util_industExp, 1.0E-10F);
			
			r.exp_coeffS_indust = 0.8F * (r.indust_expS_indust / r.util_industExp)
			+ 0.2F * (r.econ_distS_indust / r.econ_distSum);
			r.exp_coeffS_agri = 0.8F * (r.indust_expS_agri / r.util_industExp)
			+ 0.2F * (r.econ_distS_agri / r.econ_distSum);
			r.exp_coeffS_advTech = 0.8F * (r.indust_expS_advTech / r.util_industExp)
			+ 0.2F * (r.econ_distS_advTech / r.econ_distSum);
			r.exp_coeffS_other = 0.8F * (r.indust_expS_other / r.util_industExp)
			+ 0.2F * (r.econ_distS_other / r.econ_distSum);
			r.exp_coeffS_overhead = 0.8F * (r.indust_expS_overhead / r.util_industExp)
			+ 0.2F * (r.econ_distS_overhead / r.econ_distSum);
		}
	}
	
	
	public void regExpAvailB() {
		debugMsg(2, 127, "regExpAvailB");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			r.exp_avail = r.econ_distS_exp * r.educ_effic * r.industBase_stat;
			
			w.indust_expAvail += r.exp_avail;
			
			r.indust_expAvailS_indust = r.exp_avail * r.exp_coeffS_indust;
			r.indust_expAvailS_agri = r.exp_avail * r.exp_coeffS_agri;
			r.indust_expAvailS_advTech = r.exp_avail * r.exp_coeffS_advTech;
			r.indust_expAvailS_other = r.exp_avail * r.exp_coeffS_other;
			r.indust_expAvailS_overhead = r.exp_avail * r.exp_coeffS_overhead;
			
			if (r.indust_expAvailS_indust < 10000.0F) r.indust_expAvailS_indust = 0.0F;
			if (r.indust_expAvailS_agri < 10000.0F) r.indust_expAvailS_agri = 0.0F;
			if (r.indust_expAvailS_advTech < 10000.0F) r.indust_expAvailS_advTech = 0.0F;
			if (r.indust_expAvailS_other < 10000.0F) r.indust_expAvailS_other = 0.0F;
			if (r.indust_expAvailS_overhead < 10000.0F) r.indust_expAvailS_overhead = 0.0F;
			
			r.indust_expS_indust = 0.0F;
			r.indust_expS_agri = 0.0F;
			r.indust_expS_advTech = 0.0F;
			r.indust_expS_other = 0.0F;
			r.indust_expS_overhead = 0.0F;
			
			w.indust_expAvailS_indust += r.indust_expAvailS_indust;
			w.indust_expAvailS_agri += r.indust_expAvailS_agri;
			w.indust_expAvailS_advTech += r.indust_expAvailS_advTech;
			w.indust_expAvailS_other += r.indust_expAvailS_other;
			w.indust_expAvailS_overhead += r.indust_expAvailS_overhead;
			
			r.indust_imp = 0.0F;
			r.util_industExp= 0.0F;
		}
	}
	
	
	public void worldPrepareImpExp() {
		debugMsg(2, 127, "worldPrepareImpExp");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		w.food_surpUtil = w.food_surp * w.food_price;
		w.food_imp = 0.0F;
		w.nonrenew_expUtil = w.nonrenew_exp * w.nonrenew_price;
		w.nonrenew_imp = 0.0F;
		w.coal_expUtil = w.coal_expAvail * w.coal_price;
		w.coal_imp = 0.0F;
		w.oil_expUtil = w.oil_expAvail * w.oil_price;
		w.oil_imp = 0.0F;
		
		w.indust_imp = 0.0F;
		w.indust_exp = 0.0F;
		w.util_imp = 0.0F;
		
		w.indust_impS_indust = 0.0F;
		w.indust_impS_agri = 0.0F;
		w.indust_impS_advTech = 0.0F;
		w.indust_impS_other = 0.0F;
		w.indust_impS_overhead = 0.0F;
		
		w.indust_expS_indust = 0.0F;
		w.indust_expS_agri = 0.0F;
		w.indust_expS_advTech = 0.0F;
		w.indust_expS_other = 0.0F;
		w.indust_expS_overhead = 0.0F;
	}
	
	
	public void regImports() {
		debugMsg(2, 128, "regImports");
		
		//BUGFIX 020214
		v.foodNeedCount = 0;
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			int regNr = regNrOfEconRanked(i);
			r = yr[v.calcYr].r[regNr];
			
			int importsDone = 0;
			
			regAddImpDmd(regNr);
			
			regFoodImpA(regNr);
			
			regDistUtil(regNr);
			
			regFoodImpB(regNr);
			
			
			if (r.util_availImp > s.minImpUtil) {
				regOilImp(regNr);
				importsDone++;
			}
			if ((importsDone == 1) & (r.util_availImp > 0.0F)) {
				regCoalImp(regNr);
				importsDone++;
			}
			if ((importsDone == 2) & (r.util_availImp > 0.0F)) {
				regNonrenewImp(regNr);
				importsDone++;
			}
			
			if ((importsDone == 3) & (r.util_availImp > s.minImpUtil)
			& (w.indust_expAvail > 0.001F)
			& (r.imp_dmd > 0.001F)) {
				regAgriImp(regNr);
				regIndustImp(regNr);
				regAdvTechImp(regNr);
				regOtherImp(regNr);
				regOverheadImp(regNr);
				
				w.indust_imp += r.indust_imp;
				r.util_availImp = Math.max(0.0F, (r.util_availImp - r.indust_imp));
			}
			else {
				r.indust_imp = 0.0F;
				r.util_availImp = 0.0F;
				
				r.imp_byS_indust = 0.0F;
				r.imp_byS_agri = 0.0F;
				r.imp_byS_advTech = 0.0F;
				r.imp_byS_other = 0.0F;
				r.imp_byS_overhead = 0.0F;
			}
			
			switch (importsDone) {
				case 0:
					r.util_oilImp = 0.0F;
					r.oil_imp = 0.0F;
					r.oil_consum = r.oil_domProd;
					r.oil_supply2Dmd = deNaN(r.oil_consum / r.oil_dmd);
				case 1:
					r.util_coalImp = 0.0F;
					r.coal_imp = 0.0F;
				case 2:
					r.nonrenew_imp = 0.0F;
					r.util_nonrenewImp = 0.0F;
					r.nonrenew_throughput = r.nonrenew_recycled + r.nonrenew_consum;
			}
			
			
			r.util_loss = r.util_foodImp + r.util_oilImp + r.util_coalImp + r.util_nonrenewImp
			+ r.indust_imp;
			w.util_imp += r.util_loss;
			if (r.util_availImp < s.minImpUtil) r.util_availImp = 0.0F;
		}
	}
	
	
	public void regAddImpDmd(int regNr) {
		debugMsg(3, 129, "regAddImpDmd");
		
		r = yr[v.calcYr].r[regNr];
		
		if (r.util_avail >= 0.2F * r.econ_gnp) {
			float impDmdT = 0.0F;
			
			//BUGFIX (NaN-Fix) 020214
			r.imp_dmd = Math.max(r.imp_dmd, 1.0E-10F);
			
			r.imp_dmdS_indust += (r.imp_dmdS_indust / r.imp_dmd) * 0.4F * r.util_avail
			+ 0.08F * r.util_avail * r.util_targetS_indust;
			r.imp_dmdS_agri += (r.imp_dmdS_agri / r.imp_dmd) * 0.4F * r.util_avail
			+ 0.08F * r.util_avail * r.util_targetS_agri;
			r.imp_dmdS_advTech += (r.imp_dmdS_advTech / r.imp_dmd) * 0.4F * r.util_avail
			+ 0.08F * r.util_avail * r.util_targetS_advTech;
			r.imp_dmdS_other += (r.imp_dmdS_other / r.imp_dmd) * 0.4F * r.util_avail
			+ 0.08F * r.util_avail * r.util_targetS_other;
			r.imp_dmdS_overhead += (r.imp_dmdS_indust / r.imp_dmd) * 0.4F * r.util_avail
			+ 0.02F * r.util_avail;
			
			r.imp_dmd = r.imp_dmdS_indust
			+ r.imp_dmdS_agri
			+ r.imp_dmdS_advTech
			+ r.imp_dmdS_other
			+ r.imp_dmdS_overhead;
		}
	}
	
	
	public void regFoodImpA(int regNr) {
		debugMsg(3, 130, "regFoodImpA");
		
		w = yr[v.calcYr].w;
		r = yr[v.calcYr].r[regNr];
		
		if (r.food_dmd > 0.0F) {
			r.util_foodImp = Math.min(0.2F * r.food_dmd * w.food_price, w.food_surpUtil);
			r.util_foodImp = Math.min(r.util_foodImp, 0.5F * r.util_availImp);
			r.util_availImp -= r.util_foodImp;
			w.food_surpUtil -= r.util_foodImp;
			if (w.food_surpUtil < 0.0F) w.food_surpUtil = 0.0F;
		}
		else {
			r.util_foodImp = 0.0F;
		}
	}
	
	
	public void regDistUtil(int regNr) {
		debugMsg(3, 131, "regDistUtil");
		
		w = yr[v.calcYr].w;
		r = yr[v.calcYr].r[regNr];
		
		
		r.util_dmdFactR_food = Math.min(0.8F * r.food_dmd * w.food_price, w.food_surpUtil);
		r.util_dmdFactR_oil = Math.min(2.0F * r.oil_impDmd * w.oil_price, w.oil_expUtil);
		r.util_dmdFactR_coal = Math.min(r.coal_impDmd * w.coal_price, w.coal_expUtil);
		r.util_dmdFactR_nonrenew = Math.min(r.nonrenew_dmdRemain * w.nonrenew_price, w.nonrenew_expUtil);
		
		float utilDmdT = r.imp_dmd
		+ r.util_dmdFactR_food
		+ r.util_dmdFactR_oil
		+ r.util_dmdFactR_coal
		+ r.util_dmdFactR_nonrenew;
		if (utilDmdT < 0.001F) utilDmdT = 1.0F;
		
		float dmdFactRT;
		dmdFactRT = r.util_dmdFactR_food;
		r.util_dmdFactR_food /= Math.max(utilDmdT, 0.001F);
		utilDmdT -= dmdFactRT;
		dmdFactRT = r.util_dmdFactR_oil;
		r.util_dmdFactR_oil /= Math.max(utilDmdT, 0.001F);
		utilDmdT -= dmdFactRT;
		dmdFactRT = r.util_dmdFactR_coal;
		r.util_dmdFactR_coal /= Math.max(utilDmdT, 0.001F);
		utilDmdT -= dmdFactRT;
		dmdFactRT = r.util_dmdFactR_nonrenew;
		r.util_dmdFactR_nonrenew /= Math.max(utilDmdT, 0.001F);
		utilDmdT -= dmdFactRT;
	}
	
	
	public void regFoodImpB(int regNr) {
		debugMsg(3, 132, "regFoodImpB");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		r = yr[v.calcYr].r[regNr];
		rPrevYr = yr[v.calcYr - 1].r[regNr];
		
		
		//BUGFIX 020207
		if (r.food_dmd <= 0.0F) {
			r.util_foodImp = 0.0F;
			r.food_imp = 0.0F;
			r.pop_nutLvl = 1.0F;
		}
		else {
			float agriImpT = Math.min(0.8F * r.food_dmd * w.food_price, w.food_surpUtil);
			agriImpT = Math.min(agriImpT, r.util_dmdFactR_food * r.util_availImp);
			
			r.util_foodImp += agriImpT;
			
			r.util_availImp -= agriImpT;
			w.food_surpUtil -= agriImpT;
			if (w.food_surpUtil < 0.0F) w.food_surpUtil = 0.0F;
			
			r.food_imp = r.util_foodImp / w.food_price;
			w.food_imp += r.food_imp;
			
			float foodT = (((r.food_delivMult * r.food_prod) + r.food_imp) * s.grain2CalC)
			/ rPrevYr.pop_stat;
			
			float calNutLvlT = Math.min((foodT / r.food_calPerCapDayNeed), 1.0F);
			
			float animalProteinNutLvlT;
			if (calNutLvlT < 1.0F) animalProteinNutLvlT = 0.0F;
			else animalProteinNutLvlT = (foodT - r.food_calPerCapDayNeed) / 2000.0F;
			
			r.pop_nutLvl = 0.8F * calNutLvlT + 0.2F * animalProteinNutLvlT;
			
			//calculating need of food aid
			if (s.foodAidFlag & (r.pop_nutLvl <= 0.75F)
			& (r.rankByIncome > (v.numRegs - v.numFoodNeedRegs))) {
				
				v.regNrOfFoodNeedReg[v.foodNeedCount++] = regNr;
				r.food_need = (0.76F - r.pop_nutLvl) * r.food_calPerCapDayNeed
				* s.foodAid2Need;
			}
			else {
				r.food_need = 0.0F;
			}
		}
	}
	
	
	public void regOilImp(int regNr) {
		debugMsg(3, 133, "regOilImp");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		r = yr[v.calcYr].r[regNr];
		
		
		if (r.util_availImp > s.minImpUtil) {
			r.util_oilImp = Math.min(r.oil_impDmd * w.oil_price, w.oil_expUtil);
			r.util_oilImp = Math.min(r.util_oilImp, r.util_dmdFactR_oil * r.util_availImp);
			
			r.util_availImp -= r.util_oilImp;
			w.oil_expUtil -= r.util_oilImp;
			if (w.oil_expUtil < 0.0F) w.oil_expUtil = 0.0F;
			
			r.oil_imp = r.util_oilImp / w.oil_price;
			w.oil_imp += r.oil_imp;
			
			//BUGFIX 020207
			r.oil_consum = r.oil_domProd + r.oil_imp;
			r.oil_supply2Dmd = r.oil_consum / r.oil_dmd;
		}
		else {
			r.util_oilImp = 0.0F;
			r.oil_imp = 0.0F;
			r.oil_consum = r.oil_domProd;
			r.oil_supply2Dmd = r.oil_consum / r.oil_dmd;
		}
	}
	
	
	public void regCoalImp(int regNr) {
		debugMsg(3, 134, "regCoalImp");
		
		w = yr[v.calcYr].w;
		r = yr[v.calcYr].r[regNr];
		
		
		if (r.util_availImp > 0.0F) {
			r.util_coalImp = Math.min(r.coal_impDmd * w.coal_price, w.coal_expUtil);
			r.util_coalImp = Math.min(r.util_coalImp, r.util_dmdFactR_coal * r.util_availImp);
			
			r.util_availImp -= r.util_coalImp;
			w.coal_expUtil -= r.util_coalImp;
			if (w.coal_expUtil < 0.0F) w.coal_expUtil = 0.0F;
			
			r.coal_imp = r.util_coalImp / w.coal_price;
			r.coal_supply2Dmd = (r.coal_prod + r.coal_imp) / r.coal_dmd;
			
			w.coal_imp += r.coal_imp;
		}
		else {
			r.util_coalImp = 0.0F;
			r.coal_imp = 0.0F;
		}
	}
	
	
	public void regNonrenewImp(int regNr) {
		debugMsg(3, 135, "regNonrenewImp");
		
		w = yr[v.calcYr].w;
		r = yr[v.calcYr].r[regNr];
		
		if (r.util_availImp > 0.0F) {
			r.util_nonrenewImp = Math.min(r.nonrenew_dmdRemain * w.nonrenew_price, w.nonrenew_expUtil);
			r.util_nonrenewImp = Math.min(r.util_nonrenewImp, r.util_dmdFactR_nonrenew * r.util_availImp);
			
			r.util_availImp -= r.util_nonrenewImp;
			w.nonrenew_expUtil -= r.util_nonrenewImp;
			if (w.nonrenew_expUtil < 0.0F) w.nonrenew_expUtil = 0.0F;
			
			r.nonrenew_imp = r.util_nonrenewImp / w.nonrenew_price;
			r.nonrenew_throughput = r.nonrenew_recycled + r.nonrenew_consum + r.nonrenew_imp;
			
			w.nonrenew_imp += r.nonrenew_imp;
		}
		else {
			r.nonrenew_imp = 0.0F;
			r.util_nonrenewImp = 0.0F;
			r.nonrenew_throughput = r.nonrenew_recycled + r.nonrenew_consum;
		}
	}
	
	
	public void regIndustImp(int regNr) {
		debugMsg(3, 136, "regIndustImp");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		r = yr[v.calcYr].r[regNr];
		
		if ((r.imp_dmdS_indust > 0.001F) & (w.indust_expAvailS_indust > 0.001F)) {
			r.imp_byS_indust = Math.min(r.imp_dmdS_indust,
			(w.indust_expAvailS_indust - r.indust_expAvailS_indust));
			r.imp_byS_indust = Math.min(r.imp_byS_indust,
			((r.imp_dmdS_indust / r.imp_dmd) * r.util_availImp));
			
			r.indust_imp += r.imp_byS_indust;
			
			w.indust_impS_indust += r.imp_byS_indust;
			w.indust_expS_indust += r.imp_byS_indust;
			
			if (w.indust_expAvailS_indust > r.indust_expAvailS_indust) {
				float worldExpFracT = r.imp_byS_indust
				/ (w.indust_expAvailS_indust - r.indust_expAvailS_indust);
				
				for (int j = 0; j < v.numRegs; j++) {
					RegionData rExp = yr[v.calcYr].r[j];
					
					if ((j != regNr) & (rExp.indust_expAvailS_indust > 0.001F)) {
						float expT = worldExpFracT * rExp.indust_expAvailS_indust;
						
						rExp.indust_expS_indust += expT;
						rExp.indust_expAvailS_indust = Math.max(0.0F,
						(rExp.indust_expAvailS_indust - expT));
						rExp.util_industExp+= expT;
						w.indust_exp += expT;
					}
				}
				
				w.indust_expAvailS_indust -= r.imp_byS_indust;
			}
			else {
				r.imp_byS_indust = 0.0F;
			}
		}
		else {
			r.imp_byS_indust = 0.0F;
		}
	}
	
	//_very_ similar to regIndustImp
	public void regAgriImp(int regNr) {
		debugMsg(3, 137, "regAgriImp");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		r = yr[v.calcYr].r[regNr];
		
		if ((r.imp_dmdS_indust > 0.001F) & (w.indust_expAvailS_agri > 0.001F)) {
			r.imp_byS_agri = Math.min(r.imp_dmdS_agri,
			(w.indust_expAvailS_agri - r.indust_expAvailS_agri));
			r.imp_byS_agri = Math.min(r.imp_byS_agri,
			((r.imp_dmdS_agri / r.imp_dmd) * r.util_availImp));
			
			r.indust_imp += r.imp_byS_agri;
			
			w.indust_impS_agri += r.imp_byS_agri;
			w.indust_expS_agri += r.imp_byS_agri;
			
			if (w.indust_expAvailS_agri > r.indust_expAvailS_agri) {
				float worldExpFracT = r.imp_byS_agri
				/ (w.indust_expAvailS_agri - r.indust_expAvailS_agri);
				
				for (int j = 0; j < v.numRegs; j++) {
					RegionData rExp = yr[v.calcYr].r[j];
					
					if ((j != regNr) & (rExp.indust_expAvailS_agri > 0.001F)) {
						float expT = worldExpFracT * rExp.indust_expAvailS_agri;
						
						rExp.indust_expS_agri += expT;
						rExp.indust_expAvailS_agri = Math.max(0.0F,
						(rExp.indust_expAvailS_agri - expT));
						rExp.util_industExp+= expT;
						w.indust_exp += expT;
					}
				}
				
				w.indust_expAvailS_agri -= r.imp_byS_agri;
			}
			else {
				r.imp_byS_agri = 0.0F;
			}
		}
		else {
			r.imp_byS_agri = 0.0F;
		}
	}
	
	//_very_ similar to regIndustImp
	public void regAdvTechImp(int regNr) {
		debugMsg(3, 138, "regAdvTechImp");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		r = yr[v.calcYr].r[regNr];
		
		if ((r.imp_dmdS_advTech > 0.001F) & (w.indust_expAvailS_advTech > 0.001F)) {
			r.imp_byS_advTech = Math.min(r.imp_dmdS_advTech,
			(w.indust_expAvailS_advTech - r.indust_expAvailS_advTech));
			r.imp_byS_advTech = Math.min(r.imp_byS_advTech,
			((r.imp_dmdS_advTech / r.imp_dmd) * r.util_availImp));
			
			r.indust_imp += r.imp_byS_advTech;
			
			w.indust_impS_advTech += r.imp_byS_advTech;
			w.indust_expS_advTech += r.imp_byS_advTech;
			
			if (w.indust_expAvailS_advTech > r.indust_expAvailS_advTech) {
				float worldExpFracT = r.imp_byS_advTech
				/ (w.indust_expAvailS_advTech - r.indust_expAvailS_advTech);
				
				for (int j = 0; j < v.numRegs; j++) {
					RegionData rExp = yr[v.calcYr].r[j];
					
					if ((j != regNr) & (rExp.indust_expAvailS_advTech > 0.001F)) {
						float expT = worldExpFracT * rExp.indust_expAvailS_advTech;
						
						rExp.indust_expS_advTech += expT;
						rExp.indust_expAvailS_advTech = Math.max(0.0F,
						(rExp.indust_expAvailS_advTech - expT));
						rExp.util_industExp+= expT;
						w.indust_exp += expT;
					}
				}
				
				w.indust_expAvailS_advTech -= r.imp_byS_advTech;
			}
			else {
				r.imp_byS_advTech = 0.0F;
			}
		}
		else {
			r.imp_byS_advTech = 0.0F;
		}
	}
	
	//_very_ similar to regIndustImp
	public void regOtherImp(int regNr) {
		debugMsg(3, 139, "regOtherImp");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		r = yr[v.calcYr].r[regNr];
		
		if ((r.imp_dmdS_other > 0.001F) & (w.indust_expAvailS_other > 0.001F)) {
			r.imp_byS_other = Math.min(r.imp_dmdS_other,
			(w.indust_expAvailS_other - r.indust_expAvailS_other));
			r.imp_byS_other = Math.min(r.imp_byS_other,
			((r.imp_dmdS_other / r.imp_dmd) * r.util_availImp));
			
			r.indust_imp += r.imp_byS_other;
			
			w.indust_impS_other += r.imp_byS_other;
			w.indust_expS_other += r.imp_byS_other;
			
			if (w.indust_expAvailS_other > r.indust_expAvailS_other) {
				float worldExpFracT = r.imp_byS_other
				/ (w.indust_expAvailS_other - r.indust_expAvailS_other);
				
				for (int j = 0; j < v.numRegs; j++) {
					RegionData rExp = yr[v.calcYr].r[j];
					
					if ((j != regNr) & (rExp.indust_expAvailS_other > 0.001F)) {
						float expT = worldExpFracT * rExp.indust_expAvailS_other;
						
						rExp.indust_expS_other += expT;
						rExp.indust_expAvailS_other = Math.max(0.0F,
						(rExp.indust_expAvailS_other - expT));
						rExp.util_industExp+= expT;
						w.indust_exp += expT;
					}
				}
				
				w.indust_expAvailS_other -= r.imp_byS_other;
			}
			else {
				r.imp_byS_other = 0.0F;
			}
		}
		else {
			r.imp_byS_other = 0.0F;
		}
	}
	
	//_very_ similar to regIndustImp
	public void regOverheadImp(int regNr) {
		debugMsg(3, 140, "regOverheadImp");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		r = yr[v.calcYr].r[regNr];
		
		if ((r.imp_dmdS_overhead > 0.001F) & (w.indust_expAvailS_overhead > 0.001F)) {
			r.imp_byS_overhead = Math.min(r.imp_dmdS_overhead,
			(w.indust_expAvailS_overhead - r.indust_expAvailS_overhead));
			r.imp_byS_overhead = Math.min(r.imp_byS_overhead,
			((r.imp_dmdS_overhead / r.imp_dmd) * r.util_availImp));
			
			r.indust_imp += r.imp_byS_overhead;
			
			w.indust_impS_overhead += r.imp_byS_overhead;
			w.indust_expS_overhead += r.imp_byS_overhead;
			
			if (w.indust_expAvailS_overhead > r.indust_expAvailS_overhead) {
				float worldExpFracT = r.imp_byS_overhead
				/ (w.indust_expAvailS_overhead - r.indust_expAvailS_overhead);
				
				for (int j = 0; j < v.numRegs; j++) {
					RegionData rExp = yr[v.calcYr].r[j];
					
					if ((j != regNr) & (rExp.indust_expAvailS_overhead > 0.001F)) {
						float expT = worldExpFracT * rExp.indust_expAvailS_overhead;
						
						rExp.indust_expS_overhead += expT;
						rExp.indust_expAvailS_overhead = Math.max(0.0F,
						(rExp.indust_expAvailS_overhead - expT));
						rExp.util_industExp+= expT;
						w.indust_exp += expT;
					}
				}
				
				w.indust_expAvailS_overhead -= r.imp_byS_overhead;
			}
			else {
				r.imp_byS_overhead = 0.0F;
			}
		}
		else {
			r.imp_byS_overhead = 0.0F;
		}
	}
	
	
	public void worldSetVarsB() {
		debugMsg(2, 141, "worldSetVarsB");
		
		w = yr[v.calcYr].w;
		
		w.food_aid = 0.0F;
		w.nonrenew_stat = 0.0F;
		w.industBase_stat = 0.0F;
		w.advTech_stat = 0.0F;
		w.util_exp = 0.0F;
		
		w.nonrenew_fact = w.nonrenew_stat / w.area;
	}
	
	
	public void regFoodExpNAid() {
		debugMsg(2, 142, "regFoodExpNAid");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		v.foodAidCount = 0;
		
		for (int i = 0; i < v.numRegs; i++) {
			RegionData r = yr[v.calcYr].r[i];
			RegionData rPrevYr = yr[v.calcYr - 1].r[i];
			
			if ((r.food_dmd <= 0)
			& (r.food_surplus >= Math.max(0.005F * rPrevYr.pop_stat, 100000.0F))
			& (w.food_surp > 0.0F)) {
				
				r.food_exp = 0.9F * r.food_surplus * (w.food_imp / w.food_surp);
				r.food_surplus = Math.max(r.food_surplus - r.food_exp, 0.0F);
				if (r.food_surplus < 1000.0F) r.food_surplus = 0.0F;
				
				if (s.foodAidFlag & (r.food_surplus > s.minAgriSurp)) {
					//rw3l - code for user input
					w.food_aid += r.food_surp2Aid * r.food_surplus;
					//w.food_aid += s.foodSurp2Aid * r.food_surplus;
					v.regNrOfFoodAidReg[v.foodAidCount++] = i;
				}
				
				r.util_foodExp = r.food_exp * w.food_price;
			}
			else {
				r.food_exp = 0.0F;
				r.util_foodExp = 0.0F;
			}
		}
	}
	
	
	public void regOilCoalNonrenewExp() {
		debugMsg(2, 143, "regOilCoalNonrenewExp");
		
		w = yr[v.calcYr].w;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			
			//oil
			if (w.oil_expAvail > 0.0F)
				r.oil_exp = r.oil_expAvail * (w.oil_imp / w.oil_expAvail);
			else
				r.oil_exp = 0.0F;
			r.oil_prod = r.oil_domProd + r.oil_exp;
			r.util_oilExp = r.oil_exp * w.oil_price;
			
			//coal
			if (w.coal_expAvail > 0.0F) {
				r.coal_exp = r.coal_expAvail * (w.coal_imp / w.coal_expAvail);
				r.util_coalExp = r.coal_exp * w.coal_price;
			}
			else {
				r.coal_exp = 0.0F;
				r.util_coalExp = 0.0F;
			}
			//BUGFIX 020211
			r.coal_resource = r.coal_resource - r.coal_prod - r.coal_exp;
			
			//nonrenew
			if (w.nonrenew_exp > 0.0F) {
				r.nonrenew_exp = r.nonrenew_expSurp * (w.nonrenew_imp / w.nonrenew_exp);
				r.util_nonrenewExp = r.nonrenew_exp * w.nonrenew_price;
			}
			else {
				r.nonrenew_exp = 0.0F;
				r.util_nonrenewExp = 0.0F;
			}
			//BUGFIX 020211
			r.nonrenew_stat = r.nonrenew_stat - r.nonrenew_exp - r.nonrenew_consum;
			w.nonrenew_stat += r.nonrenew_stat;
			r.nonrenew_fact = r.nonrenew_stat / r.area;
		}
	}
	
	
	public void regProduction() {
		debugMsg(2, 144, "regProduction");
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			
			float multT = 1.0F;
			float industMultT = 1.0F;
			//BUGFIX 020215 (* to -, added forgotten max)
			if (r.econ_throughputFact > 0.0F) {
				multT += Math.min(-1.0F * r.investPerCap2BY, 0.1F - r.indust_delayedIdleFrac);
				multT = Math.max(multT, 1.0F);
				industMultT += Math.max(0.0F, Math.max(-1.0F * r.investPerCap2BY, 0.1F - r.indust_delayedIdleFrac));
				industMultT = Math.max(industMultT, 1.0F);
			}
			
			//BUGFIX 020207
			r.exp_avail = Math.max(r.exp_avail, 1.0E-10F);
			
			r.econ_distS_indust *= industMultT;
			r.econ_distS_indust += r.econ_distS_exp * (r.indust_expS_indust / r.exp_avail);
			r.econ_distS_agri *= multT;
			r.econ_distS_agri += r.econ_distS_exp * (r.indust_expS_agri / r.exp_avail);
			r.econ_distS_advTech *= multT;
			r.econ_distS_advTech += r.econ_distS_exp * (r.indust_expS_advTech / r.exp_avail);
			r.econ_distS_other *= multT;
			r.econ_distS_other += r.econ_distS_exp * (r.indust_expS_other / r.exp_avail);
			r.econ_distS_overhead *= multT;
			r.econ_distS_overhead += r.econ_distS_exp * (r.indust_expS_overhead / r.exp_avail);
			
			float distSumT = r.econ_distS_indust
			+ r.econ_distS_agri
			+ r.econ_distS_advTech
			+ r.econ_distS_other
			+ r.econ_distS_overhead;
			
			float desT = r.exp_avail * r.exp_coeffS_indust;
			if ((desT > 0) & (((desT - r.indust_expS_indust) / desT) > 0.3F))
				r.exp_coeffS_indust = Math.max((r.exp_coeffS_indust - 0.01F), 0.0F);
			if ((desT > 0) & (((desT - r.indust_expS_indust) / desT) <= 0.2F))
				r.exp_coeffS_indust += 0.01F;
			desT = r.exp_avail * r.exp_coeffS_agri;
			if ((desT > 0) & (((desT - r.indust_expS_agri) / desT) > 0.3F))
				r.exp_coeffS_agri = Math.max((r.exp_coeffS_agri - 0.01F), 0.0F);
			if ((desT > 0) & (((desT - r.indust_expS_agri) / desT) <= 0.2F))
				r.exp_coeffS_agri += 0.01F;
			desT = r.exp_avail * r.exp_coeffS_advTech;
			if ((desT > 0) & (((desT - r.indust_expS_advTech) / desT) > 0.3F))
				r.exp_coeffS_advTech = Math.max((r.exp_coeffS_advTech - 0.01F), 0.0F);
			if ((desT > 0) & (((desT - r.indust_expS_advTech) / desT) <= 0.2F))
				r.exp_coeffS_advTech += 0.01F;
			desT = r.exp_avail * r.exp_coeffS_other;
			if ((desT > 0) & (((desT - r.indust_expS_other) / desT) > 0.3F))
				r.exp_coeffS_other = Math.max((r.exp_coeffS_other - 0.01F), 0.0F);
			if ((desT > 0) & (((desT - r.indust_expS_other) / desT) <= 0.2F))
				r.exp_coeffS_other += 0.01F;
			desT = r.exp_avail * r.exp_coeffS_overhead;
			if ((desT > 0) & (((desT - r.indust_expS_overhead) / desT) > 0.3F))
				r.exp_coeffS_overhead = Math.max((r.exp_coeffS_overhead - 0.01F), 0.0F);
			if ((desT > 0) & (((desT - r.indust_expS_overhead) / desT) <= 0.2F))
				r.exp_coeffS_overhead += 0.01F;
			
			float expSumT = r.exp_coeffS_indust
			+ r.exp_coeffS_agri
			+ r.exp_coeffS_advTech
			+ r.exp_coeffS_other
			+ r.exp_coeffS_overhead;
			
			r.indust_prod = r.educ_effic * r.industBase_stat * distSumT;
			
			r.indust_idleFrac = Math.max((1.0F - distSumT), 0.0F);
			
			if (expSumT >= 0.001F) {
				r.exp_coeffS_indust /= expSumT;
				r.exp_coeffS_agri /= expSumT;
				r.exp_coeffS_advTech /= expSumT;
				r.exp_coeffS_other /= expSumT;
				r.exp_coeffS_overhead /= expSumT;
			}
		}
	}
	
	
	public void regStatUtilsTNI() {
		debugMsg(2, 145, "regStatUtilsTNI");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			
			r.util_gain = r.util_foodExp + r.util_oilExp + r.util_coalExp + r.util_nonrenewExp
			+ r.util_industExp;
			w.util_exp += r.util_gain;
			
			r.util_avail += r.util_gain - r.util_loss;
			
			//BUGFIX 020207
			//- r.imp... to + r.imp...
			r.industBase_stat = r.util_investS_indust * r.util_tni * (1.0F - s.decay_indust)
			+ r.indust_prod
			* (r.econ_distS_indust
			- r.econ_distS_exp * (r.indust_expS_indust / r.exp_avail))
			+ r.imp_byS_indust;
			r.agriEquip_stat = r.util_investS_agri * r.util_tni * (1.0F - s.decay_agri)
			+ r.indust_prod
			* (r.econ_distS_agri
			- r.econ_distS_exp * (r.indust_expS_agri / r.exp_avail))
			+ r.imp_byS_agri;
			r.advTech_stat = r.util_investS_advTech * r.util_tni * (1.0F - s.decay_advTech)
			+ r.indust_prod
			* (r.econ_distS_advTech
			- r.econ_distS_exp * (r.indust_expS_advTech / r.exp_avail))
			+ r.imp_byS_advTech;
			r.other_stat = r.util_investS_other * r.util_tni * (1.0F - s.decay_other)
			+ r.indust_prod
			* (r.econ_distS_other
			- r.econ_distS_exp * (r.indust_expS_other / r.exp_avail))
			+ r.imp_byS_other;
			
			r.industBase_stat = deZero(r.industBase_stat);
			r.agriEquip_stat = deZero(r.agriEquip_stat);
			r.advTech_stat = deZero(r.advTech_stat);
			r.other_stat = deZero(r.other_stat);
			
			r.util_tni = r.industBase_stat + r.agriEquip_stat + r.advTech_stat + r.other_stat;
			
			w.industBase_stat += r.industBase_stat;
			w.advTech_stat += r.advTech_stat;
			
			//BUGFIX 020207
			r.util_investS_indust = r.industBase_stat / r.util_tni;
			r.util_investS_agri = r.agriEquip_stat / r.util_tni;
			r.util_investS_advTech = r.advTech_stat / r.util_tni;
			r.util_investS_other = r.other_stat / r.util_tni;
		}
	}
	
	
	public void regRankByFoodNeed() {
		debugMsg(2, 146, "regRankByFoodNeed");
		
		//		rw3-original code
		//		int rankT;
		//		for (int i = 0; i < v.numRegs; i++) {
		//			rankT = 0;
		//			for (int j = 0; j < v.numRegs; j++) {
		//				if (yr[v.calcYr].r[j].food_need > yr[v.calcYr].r[i].food_need)
		//					rankT++;
		//			}
		//			yr[v.calcYr].r[i].rankByFoodNeed = rankT;
		//		}
		
		//		sepp 020314; improved sorting mechanism
		float[] vals = new float[v.numRegs];
		for (int i = 0; i < v.numRegs; i++) {
			vals[i] = yr[v.calcYr].r[i].food_need;
		}
		int[] result = sortMe(vals);
		
		for (int i = 0; i < v.numRegs; i++) {
			yr[v.calcYr].r[i].rankByFoodNeed = result[i];
		}
	}
	
	
	public int regNrOfFoodNeedRanked(int rank) {
		//debugMsg(2, 147, "regNrOfFoodNeedRanked(" + rank + ")");
		
		for (int i = 0; i < v.numRegs; i++) {
			if (yr[v.calcYr].r[i].rankByFoodNeed == rank) return i;
		}
		
		return 0;
	}
	
	
	public void regFoodAid() {
		debugMsg(2, 148, "regFoodAid");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		w.food_aidAvail = w.food_aid;
		
		for (int i = 0; i < v.foodNeedCount; i++) {
			r = yr[v.calcYr].r[regNrOfFoodNeedRanked(i)];
			rPrevYr = yr[v.calcYr - 1].r[regNrOfFoodNeedRanked(i)];
			
			r.food_need *= s.cal2TonConvC * rPrevYr.pop_stat;
			
			if (w.food_aid > 0.001F) {
				r.food_aidRecv = Math.min(w.food_aid, r.food_need);
				w.food_aid -= r.food_aidRecv;
				
				//BUGFIX 020207
				r.pop_nutLvl = 0.8F * (((r.food_delivMult * r.food_prod)
				+ r.food_imp
				+ r.food_aidRecv) * s.grain2CalC / rPrevYr.pop_stat)
				/ r.food_calPerCapDayNeed;
			}
			else {
				r.food_aidRecv = 0.0F;
			}
			
			//BUGFIX 020409
			r.food_need = 0.0F;
		}
		
		for (int i = 0; i < v.foodAidCount; i++) {
			r = yr[v.calcYr].r[v.regNrOfFoodAidReg[i]];
			
			//r.food_aidGiven = s.foodSurp2Aid * r.food_surplus
			//rw3l - code for user input; sepp 020313
			r.food_aidGiven = r.food_surp2Aid * r.food_surplus
			* (1.0F - (w.food_aid / w.food_aidAvail));
			r.food_surplus -= r.food_aidGiven;
		}
	}
	
	
	public void regDelayedIdleFrac() {
		debugMsg(2, 149, "regDelayedIdleFrac");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			rPrevYr2 = yr[v.calcYr - 2].r[i];
			rPrevYr3 = yr[v.calcYr - 3].r[i];
			
			r.indust_delayedIdleFrac = r.indust_idleFrac * 0.4F
			+ rPrevYr.indust_idleFrac * 0.3F
			+ rPrevYr2.indust_idleFrac * 0.2F
			+ rPrevYr3.indust_idleFrac * 0.1F;
		}
	}
	
	
	public void regOilDist() {
		debugMsg(2, 150, "regOilDist");
		
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			
			if (Math.abs(r.oil_imp - r.oil_impDmd) < 10.0F) {
				r.oil_distCoeffS_indust = r.oil_dmdNS_indust;
				r.oil_distCoeffS_agri = r.oil_dmdNS_agri;
				r.oil_distCoeffS_advTech = r.oil_dmdNS_advTech;
				r.oil_distCoeffS_other = r.oil_dmdNS_other;
				
				r.oil_consum2Dmd = 1.0F;
			}
			else {
				float energyIndustT = r.oil_dmdNS_indust;
				float energyAgriT = r.oil_dmdNS_agri;
				float energyAdvTechT = r.oil_dmdNS_advTech;
				float energyOtherT = r.oil_dmdNS_other;
				
				float allocIndustT = s.energyAllocS_indust;
				float allocAgriT = s.energyAllocS_agri;
				float allocAdvTechT = s.energyAllocS_advTech;
				float allocOtherT = s.energyAllocS_other;
				
				float shortIndustT = allocIndustT * (1.0F - r.oil_supply2Dmd);
				float shortAgriT = allocAgriT * (1.0F - r.oil_supply2Dmd);
				float shortAdvTechT = allocAdvTechT * (1.0F - r.oil_supply2Dmd);
				float shortOtherT = allocOtherT * (1.0F - r.oil_supply2Dmd);
				
				float short2DmdSumT;
				float allocSumT;
				do {
					short2DmdSumT = 0.0F;
					
					if (shortIndustT <= energyIndustT) energyIndustT -= shortIndustT;
					else {
						short2DmdSumT += (shortIndustT - energyIndustT);
						allocIndustT = 0.0F;
						energyIndustT = 0.0F;
					}
					if (shortAgriT <= energyAgriT) energyAgriT -= shortAgriT;
					else {
						short2DmdSumT += (shortAgriT - energyAgriT);
						allocAgriT = 0.0F;
						energyAgriT = 0.0F;
					}
					if (shortAdvTechT <= energyAdvTechT) energyAdvTechT -= shortAdvTechT;
					else {
						short2DmdSumT += (shortAdvTechT - energyAdvTechT);
						allocAdvTechT = 0.0F;
						energyAdvTechT = 0.0F;
					}
					if (shortOtherT <= energyOtherT) energyOtherT -= shortOtherT;
					else {
						short2DmdSumT += (shortOtherT - energyOtherT);
						allocOtherT = 0.0F;
						energyOtherT = 0.0F;
					}
					
					if (short2DmdSumT >= 0.001F) {
						allocSumT = allocIndustT + allocAgriT + allocAdvTechT + allocOtherT;
						
						shortIndustT = (allocIndustT / allocSumT) * short2DmdSumT;
						shortAgriT = (allocAgriT / allocSumT) * short2DmdSumT;
						shortAdvTechT = (allocAdvTechT / allocSumT) * short2DmdSumT;
						shortOtherT = (allocOtherT / allocSumT) * short2DmdSumT;
					}
					//BUGFIX 020203
				} while (short2DmdSumT > 0.001F);
				
				float energySumT = energyIndustT + energyAgriT + energyAdvTechT + energyOtherT;
				
				//BUGFIX (NaNFIX) 020409
				//if (energySumT == 0.0F) energySumT = 1.0E-7F;
				energySumT = deZero(energySumT);
				
				r.oil_distCoeffS_indust = energyIndustT / energySumT;
				r.oil_distCoeffS_agri = energyAgriT / energySumT;
				r.oil_distCoeffS_advTech = energyAdvTechT / energySumT;
				r.oil_distCoeffS_other = energyOtherT / energySumT;
				
				//				//BUGFIX (NaNFIX) 020208
				//				if ((r.oil_distCoeffS_indust + "").equals(NaN)) {
				//					r.oil_distCoeffS_indust = 0.0F;
				//					r.oil_distCoeffS_agri = 0.0F;
				//					r.oil_distCoeffS_advTech = 0.0F;
				//					r.oil_distCoeffS_other = 0.0F;
				//				}
				
				r.oil_consum2Dmd = (r.oil_distCoeffS_indust * r.oil_consum) / r.indust_oilDmd;
			}
		}
	}
	
	
	public void regOilType() {
		debugMsg(2, 151, "regOilType");
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			
			r.oil_typeChangeH *= 0.9F;
			float shortage = 1.0F - r.oil_supply2Dmd;
			
			if (shortage > 0.0F) r.oil_typeChangeH += shortage;
			
			if (r.oil_typeChangeH >= 1.91F) {
				//BUGFIX 020203
				r.oil_type = Math.min(2, ++r.oil_type);
				r.oil_typeChangeH = 0.0F;
			}
			
			r.agri_oilSatMult = (r.oil_distCoeffS_agri / r.oil_dmdNS_agri)
			* (r.oil_consum / r.oil_dmd);
			
			//BUGFIX 020403
			r.agri_oilSatMult = deNaN(r.agri_oilSatMult);
		}
	}
	
	
	public void regStdOfLiving() {
		debugMsg(2, 152, "regStdOfLiving");
		
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			float otherOilSatT = (r.oil_distCoeffS_other * r.oil_consum)
			/ (r.oil_dmdCoeffS_other * r.util_tni);
			float otherT = 0.25F * ((r.other_stat / (rPrevYr.pop_stat * 5000.0F))
			* ((otherOilSatT * s.oilUse_other[r.oil_type])
			+ (1.0F - s.oilUse_other[r.oil_type]
			* r.coal_supply2Dmd)));
			r.econ_stdOfLiving = 0.035F * rPrevYr.econ_strenClass
			+ 0.1F * ((float)(v.numRegs - r.rankByIncome) / (float)v.numRegs)
			+ 0.1F * r.pop_nutLvl
			+ 0.0001F * r.econ_incomePerCap
			+ 0.25F * otherT;
		}
	}
	
	
	public void regPollution() {
		debugMsg(2, 153, "regPollution");
		
		w = yr[v.calcYr].w;
		s = yr[v.calcYr].s;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			
			float decayUtilT = s.decay_indust * r.util_investS_indust * r.util_tni
			+ s.decay_agri * r.util_investS_agri * r.util_tni
			+ s.decay_advTech * r.util_investS_advTech * r.util_tni
			+ s.decay_other * r.util_investS_other * r.util_tni;
			
			float polluteT = 0.0002F * (r.indust_prod * decayUtilT)
			+ r.coal_prod + r.coal_imp + r.oil_consum;
			
			r.pollution2Area = polluteT / r.area;
		}
	}
	
	
	public void regPopulation() {
		debugMsg(2, 154, "regPopulation");
		
		w = yr[v.calcYr].w;
		
		w.popStat = 0.0F;
		w.manHourTrainCum = 0.0F;
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			//020128: emmigration / immigration left out by now
			
			r.pop_birthRate = Math.min(0.05F,
			(10.0F * r.pop_nutLvl + 7.0F / r.tech_stat
			+ 14.0F / rPrevYr.econ_strenClass + r.pop_inAgri2Pop
			- 0.0001F * r.educ_manHourTrainCap
			- 2.5F * r.econ_stdOfLiving) * 0.001F);
			r.pop_deathRate = Math.min(0.08F,
			(6.0F - 3.0F * r.econ_stdOfLiving
			//BUGFIX 020210 (min to max, * to /)
			+ 2.5F / Math.max(r.pop_nutLvl - 0.27F, 0.02F)
			+ Math.min(0.01F * r.pollution2Area, 1.0F)
			- 0.0001F * r.educ_manHourTrainCap
			+ 3.0F / rPrevYr.econ_strenClass) * 0.001F);
			
			r.pop_stat = rPrevYr.pop_stat + rPrevYr.pop_stat * r.pop_birthRate
			- rPrevYr.pop_stat * r.pop_deathRate;
			
			float leaveAgriT = 1.0F;
			if (w.food_price > 100.0F) leaveAgriT = 0.3F;
			float oldInAgriT = r.pop_inAgri;
			
			//BUGFIX 020207
			r.pop_inAgri = oldInAgriT * r.pop_stat / rPrevYr.pop_stat
			//BUGFIX (sim change!) 020214
			//- oldInAgriT * 0.01F * leaveAgriT * r.indust_ratio
			- oldInAgriT * 0.03F * leaveAgriT * r.indust_ratio
			//+ 0.04F * (1.0F - r.pop_nutLvl) * (rPrevYr.pop_stat - oldInAgriT)
			+ Math.min(0.01F * (1.0F - r.agri_oilSatMult)
			* (rPrevYr.pop_stat - oldInAgriT),
			0.01F * oldInAgriT);
			
			r.pop_inAgri2Pop = r.pop_inAgri / r.pop_stat;
			
			w.popStat += r.pop_stat;
			
			r.educ_manHourTrainCum = r.educ_manHourTrainCum * (1.0F - r.pop_deathRate)
			* r.pop_stat / rPrevYr.pop_stat
			+ 300.0F * (r.pop_stat - r.pop_inAgri) * r.tech_ratio;
			
			r.educ_manHourTrainCap += Math.min(0.02F * (14000.0F - r.educ_manHourTrainCap),
			r.educ_manHourTrainCum / r.pop_stat - r.educ_manHourTrainCap);
			
			r.educ_manHourTrainCum = r.educ_manHourTrainCap * r.pop_stat;
			
			w.manHourTrainCum += r.educ_manHourTrainCum;
		}
		
		w.manHourTrainCap = w.manHourTrainCum / w.popStat;
	}
	
	
	public void regStrenClassA() {
		debugMsg(2, 155, "regStrenClassA");
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			
			if (r.econ_strenClass > 10) r.econ_strenClass = 10;
			else if (r.econ_strenClass < 1) r.econ_strenClass = 1;
		}
	}
	
	
	public void regStrenClassB() {
		debugMsg(2, 156, "regStrenClassB");
		
		for (int i = 0; i < v.numRegs; i++) {
			r = yr[v.calcYr].r[i];
			rPrevYr = yr[v.calcYr - 1].r[i];
			
			if (r.econ_strenClass < rPrevYr.econ_strenClass) {
				r.econ_strenClass = Math.max(rPrevYr.econ_strenClass - 2,
				r.econ_strenClass);
			}
			else if (r.econ_strenClass > rPrevYr.econ_strenClass) {
				r.econ_strenClass = rPrevYr.econ_strenClass + 1;
			}
		}
	}
	
	//ADDITION 020220
	public float smoothMe(float[] values2Sm) {
		float smoothedVal = 0.0F;
		for (int i = 0; i < values2Sm.length; i++) {
			smoothedVal = 0.5F * smoothedVal + 0.5F * values2Sm[i];
		}
		return smoothedVal;
	}
	
	//utility method, sepp 020313
	public int[] sortMe(float[] val2Sort) {
		int length = val2Sort.length;
		int[] regNrs = new int[length];
		for (int i = 0; i < length; i++) regNrs[i] = i;
		
		for (int i = 0; i < length; i++) {
			for (int j = i; j < length; j++) {
				if (val2Sort[j] > val2Sort[i]) {
					int regNrT = regNrs[j];
					float valT = val2Sort[j];
					regNrs[j] = regNrs[i];
					val2Sort[j] = val2Sort[i];
					regNrs[i] = regNrT;
					val2Sort[i] = valT;
				}
			}
		}
		
		int[] result = new int[length];
		for (int i = 0; i < length; i++) result[regNrs[i]] = i;
		return result;
		//		return regNrs;
	}
	
	//THE stupid workaround...; sepp 020403
	public float deNaN(float value) {
		if (Float.isNaN(value)) return 1.0E-7F;
		if (Float.isInfinite(value)) return 1.0E7F;
		else return value;
	}
	
	//THE even more stupid workaround; sepp 020403
	public float deZero(float value) {
		if (value <= 0.0F) return 1.0E-7F;
		else return deNaN(value);
	}
	
	public float limit(float value, float lower, float upper) {
		return Math.max(lower, Math.min(upper, value));
	}
}
