package logica.sim.data;


public class SimData {
	public boolean foodAidFlag = true;
	public float foodSurp2Aid = 0.25F;
	public float foodAid2Need = 0.33F;
	public float foodCostC = 73.0F;
	public float coalUseC = 0.002F;
	public float oilUseC = 0.0011F;
	public float cal2TonConvC = 0.0001F;
	public float grain2CalC = 10000.0F;

//	public float utilAidQualifierC = 0.3F;		//commented out for testing
	public float utilAidQualifierC = 0.0F;		//DEBUG: no limits for testing; sepp 020313
	public float util2AidFract = 0.05F;
	public float utilAidNeed2NutC = 30.0F;
	public float utilAidNeed2IncomeC = 0.25F;

	public float conservFraction = 0.6F;		//normal to conservation ratio
	public float conservMult = 4.0F;			//conservation if income > conservMult * medianIncome

	//variables added in java-model code
	public float utilAidMax = 10.0E10F;			//maximum of utils collected for aid
	public float utilAidNeedMin = 1.0E7F;		//minimum of utile-need to be considered for aid
	public float utilForFoodMin = 1.0E6F;		//minimum utils required to consider food import
	public int utilAidRegsMax = 10;  			//maximum number of regions getting utile aid
	public float coalMinedPerYr = 0.005F;		//maximum amount of coal mined per year
	public float coalExpMax = 1.0E6F;			//maximum coal for export
	public float nonrenewMinedPerYr = 0.012F;	//maximum amount of nonrenew mined per year
	public float nonrenewExpMax = 1.0E7F;		//maximum nonrenew for export
	public float minImpUtil = 1.0E6F;			//minimum utils required for import to be considered
	public float minAgriSurp = 1.0E6F;			//minimum food surplus for aid to be considered


	public float oilUse_indust[] = { 0.1F, 0.5F, 1.0F};
	public float oilUse_agri[] = { 0.6F, 0.8F, 1.0F };
	public float oilUse_advTech[] = { 0.1F, 0.5F, 0.9F };
	public float oilUse_other[] = { 0.2F, 0.6F, 1.0F };


	public float energy_indust = 1.0F;
	public float energy_agri = 0.6F;
	public float energy_advTech = 0.1F;
	public float energy_other = 0.5F;


	public float energyAllocS_indust = 0.105F;
	public float energyAllocS_agri = 0.005F;
	public float energyAllocS_advTech = 0.002F;
	public float energyAllocS_other = 0.888F;

	public float decay_indust = 0.08F;
	public float decay_agri = 0.08F;
	public float decay_advTech = 0.16F;
	public float decay_other = 0.08F;

	public float industAdd_investGTTarget = -0.01F;
	public float industAdd_investLTTarget = 0.01F;
	public float industAdd_delayedIdleFrac = 0.1F;
	public float industAdd_consum2Dmd = -0.01F;
	public float industAdd_agriOilSat = -0.03F;
	public float industAdd_investLoss = 0.05F;;

	public float agriAdd_worldFoodLoss = 0.01F;
	public float agriAdd_foodPriceMinimal = 0.01F;
	public float agriAdd_investLTTarget = -0.01F;
	public float agriAdd_foodPriceMore = 0.0002F;
	public float agriAdd_surplusGrowth = -0.01F;
	public float agriAdd_investLoss = 0.06F;
	public float agriAdd_oilSatDmd = 0.05F;

	public float advTechAdd_investLTTarget = 0.05F;
	public float advTechAdd_investGTTarget = - 0.02F;
	public float advTechAdd_manHourTrainCap = 0.04F;
	public float advTechAdd_econStrenClass = 0.02F;
	public float advTechAdd_utilAvail = 0.04F;
	public float advTechAdd_inAgri2Pop = -0.02F;
	public float advTechAdd_investLoss = 0.04F;

	public float otherAdd_investLTTarget = 0.03F;
	public float otherAdd_investGTTarget = -0.05F;
	public float otherAdd_nutLvl = 0.01F;
	public float otherAdd_utilAvailPlus = -0.02F;
	public float otherAdd_utilAvailMinus = 0.02F;
	public float otherAdd_econStrenClass = 0.002F;
	public float otherAdd_investLoss = 0.04F;

	public float overheadAdd_utilAvailPlus = 0.03F;
	public float overheadAdd_utilAvailMinus = -0.02F;
	public float overheadAdd_nutLvlGood = 0.01F;
	public float overheadAdd_nutLvlBad = -0.01F;
	public float overheadAdd_oilSatDmd = -0.08F;
	public float overheadAdd_goodIncome = -0.05F;

}