package logica.sim.io;

import logica.utility.*;
import logica.sim.*;
import logica.sim.data.*;

public class SimOutput {
	private Vars v;
	private Year[] yr;

	public Utility u;


	public SimOutput(Year[] yrArg, Vars varsArg, Utility uArg) {
		yr = yrArg;
		v = varsArg;
		u = uArg;
	}


	public float getValue(String nameOfVar, int regNr, int yrArg)
	{

		// add base Year and Check
		int requestYr = yrArg + 6;// + v.baseYr;

		if (requestYr > v.calcYr || requestYr < 0)
		{
			u.addMsg(6, "SimOutput.getValue - request for non-existing year: "+requestYr+" -  returning 0");
			return 0.0F;
		}

		if (nameOfVar.equals("pop_stat")) return yr[requestYr].r[regNr].pop_stat;
		else if(nameOfVar.equals("area")) return yr[requestYr].r[regNr].area;
		else if(nameOfVar.equals("pop_nutLvl")) return yr[requestYr].r[regNr].pop_nutLvl;
		else if(nameOfVar.equals("pop_birthRate")) return yr[requestYr].r[regNr].pop_birthRate;
		else if(nameOfVar.equals("pop_deathRate")) return yr[requestYr].r[regNr].pop_deathRate;
		else if(nameOfVar.equals("util_avail")) return yr[requestYr].r[regNr].util_avail;
		else if(nameOfVar.equals("util_availImp")) return yr[requestYr].r[regNr].util_availImp;
		else if(nameOfVar.equals("util_tni")) return yr[requestYr].r[regNr].util_tni;
		else if(nameOfVar.equals("econ_gnp")) return yr[requestYr].r[regNr].econ_gnp;
		else if(nameOfVar.equals("econ_stdOfLiving")) return yr[requestYr].r[regNr].econ_stdOfLiving;
		else if(nameOfVar.equals("econ_incomePerCap")) return yr[requestYr].r[regNr].econ_incomePerCap;
		else if(nameOfVar.equals("food_prod")) return yr[requestYr].r[regNr].food_prod;
		else if(nameOfVar.equals("indust_prod")) return yr[requestYr].r[regNr].indust_prod;
		else if(nameOfVar.equals("indust_imp")) return yr[requestYr].r[regNr].indust_imp;
		else if(nameOfVar.equals("oil_totalReserves")) return yr[requestYr].r[regNr].oil_totalReserves;
		else if(nameOfVar.equals("oil_prod")) return yr[requestYr].r[regNr].oil_prod;
		else if(nameOfVar.equals("oil_consum")) return yr[requestYr].r[regNr].oil_consum;
		else if(nameOfVar.equals("educ_manHourTrainCap")) return yr[requestYr].r[regNr].educ_manHourTrainCap;
		else if(nameOfVar.equals("tech_stat")) return yr[requestYr].r[regNr].tech_stat;
		else if(nameOfVar.equals("econ_distS_indust")) return yr[requestYr].r[regNr].econ_distS_indust;
		else if(nameOfVar.equals("econ_distS_agri")) return yr[requestYr].r[regNr].econ_distS_agri;
		else if(nameOfVar.equals("econ_distS_advTech")) return yr[requestYr].r[regNr].econ_distS_advTech;
		else if(nameOfVar.equals("econ_distS_other")) return yr[requestYr].r[regNr].econ_distS_other;
		else if(nameOfVar.equals("econ_distS_overhead")) return yr[requestYr].r[regNr].econ_distS_overhead;
		else if(nameOfVar.equals("econ_distS_exp")) return yr[requestYr].r[regNr].econ_distS_exp;

		else if(nameOfVar.equals("food_aid")) return yr[requestYr].r[regNr].food_surp2Aid;
		else if(nameOfVar.equals("util_aid")) return yr[requestYr].r[regNr].util_avail2Aid;

		else if (nameOfVar.equals("population")) return yr[requestYr].r[regNr].pop_stat;
		else if(nameOfVar.equals("nutrition level")) return yr[requestYr].r[regNr].pop_nutLvl;
		else if(nameOfVar.equals("TNI")) return yr[requestYr].r[regNr].util_tni;
		else if(nameOfVar.equals("gnp")) return yr[requestYr].r[regNr].econ_gnp;
		else if(nameOfVar.equals("standard of living")) return yr[requestYr].r[regNr].econ_stdOfLiving;
		else if(nameOfVar.equals("food production")) return yr[requestYr].r[regNr].food_prod;
		else if(nameOfVar.equals("industrial production")) return yr[requestYr].r[regNr].indust_prod;
		else if(nameOfVar.equals("production")) return yr[requestYr].r[regNr].indust_prod;
		else if(nameOfVar.equals("oil consum")) return yr[requestYr].r[regNr].oil_consum;
		else if(nameOfVar.equals("education")) return yr[requestYr].r[regNr].educ_manHourTrainCap;
		else if(nameOfVar.equals("income per cap")) return yr[requestYr].r[regNr].econ_incomePerCap;
		else if(nameOfVar.equals("investement")) return yr[requestYr].r[regNr].util_tni;
		else if(nameOfVar.equals("technology")) return yr[requestYr].r[regNr].tech_stat;
		else if(nameOfVar.equals("tni")) return yr[requestYr].r[regNr].util_tni;		


		else
		{
//			u.addMsg(6, "SimOutput.getValue - value not available - search via reflections..");
//			// return 0.0F;
//			return yr[requestYr].r[regNr].getValueRefl(nameOfVar);
			System.out.println("value not available");
			return 0.0F;
		}
	}

	public float[] getDistValue(String nameOfVar, int regNr, int yrArg)
	{
		// add base Year and Check
		int requestYr = yrArg + 6; // + v.baseYr;

		if (requestYr > v.calcYr || requestYr < 0)
		{
			u.addMsg(6, "SimOutput.getDistValue - request for non-existing year "+requestYr+" - returning 0");
			float[] dist = {0,0,0,0};
			return dist;
		}

		if (nameOfVar.equals("util_targetS"))
		{
			float[] dist = {	yr[requestYr].r[regNr].util_targetS_indust,
						yr[requestYr].r[regNr].util_targetS_agri,
						yr[requestYr].r[regNr].util_targetS_advTech,
						yr[requestYr].r[regNr].util_targetS_other };
			return dist;
		}
		else if (nameOfVar.equals("util_investS"))
		{
			float[] dist = {	yr[requestYr].r[regNr].util_investS_indust,
						yr[requestYr].r[regNr].util_investS_agri,
						yr[requestYr].r[regNr].util_investS_advTech,
						yr[requestYr].r[regNr].util_investS_other };
			return dist;
		}
		else if (nameOfVar.equals("econ_distS"))
		{
			float[] dist = {	yr[requestYr].r[regNr].econ_distS_indust,
						yr[requestYr].r[regNr].econ_distS_agri,
						yr[requestYr].r[regNr].econ_distS_advTech,
						yr[requestYr].r[regNr].econ_distS_other };
			return dist;
		}
		else
		{
			u.addMsg(6, "SimOutput.getDistValue - value not available -  returning 0");
			float[] dist = {0,0,0,0};
			return dist;
		}
	}


	public float[] getValueTime(String nameOfVar, int regNr, int yr1, int yr2)
	{
		if (yr1 > yr2 || yr1 < 0 || yr2 > v.calcYr)
		{
			u.addMsg(6, "SimOutput.getValueTime - invalid time range "+yr1+"-"+yr2+" - trying..");
		}

		int firstYr = yr1;
		int lastYr = yr2;

		//Limitations
		//int firstYr = Math.max(v.baseYr, Math.min(yr1, yr2));
		//int lastYr = Math.min(v.calcYr, Math.max(yr1, yr2));

		//regNr = Math.max(0, Math.min(regNr, v.numRegs - 1));

		float[] retVals = new float[(lastYr - firstYr) + 1];

		for (int i = firstYr; i <= lastYr; i++) {
			retVals[i - firstYr] = getValue(nameOfVar, regNr, i);
		}

		return retVals;
	}


	public float getValueWorld(String nameOfVar, int yr)
	{
		float retVal = 0.0F;

		for (int i=0; i < v.numRegs; i++) retVal += getValue(nameOfVar, i, yr);

		return retVal;
	}



	public float[] getValueWorldTime(String nameOfVar, int yr1, int yr2)
	{
		if (yr1 > yr2 || yr1 < 0 || yr2 > v.calcYr)
		{
			u.addMsg(6, "SimOutput.getValueTime - invalid time range "+yr1+"-"+yr2+" - trying..");
		}

		int firstYr = yr1;
		int lastYr = yr2;


		float[] retVals = new float[(lastYr - firstYr) + 1];

		for (int i = firstYr; i <= lastYr; i++)
		{
			retVals[i - firstYr] = 0;
			for (int j=0;j<v.numRegs;j++) retVals[i-firstYr] += getValue(nameOfVar, j, i);
		}

		return retVals;
	}


	public float[] getValueRegs(String nameOfVar, int yr) {


		if (yr > v.calcYr || yr < 0)
		{
			u.addMsg(6, "SimOutput.getValueRegs- non-existing Year "+yr+"- trying..");
		}

		//Limitations
		//yr = Math.max(v.baseYr, Math.min(yr, v.calcYr));

		float[] retVals = new float[v.numRegs];

		for (int i = 0; i < v.numRegs; i++) {
			retVals[i] = getValue(nameOfVar, i, yr);
		}

		return retVals;
	}


	public String getName(int regNr) {
		return yr[5].r[regNr].name;
	}

	public float getPosX(int regNr) {
		return yr[5].r[regNr].xPos;
	}

	public float getPosY(int regNr) {
		return yr[5].r[regNr].yPos;
	}
}