package logica.utility;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;


public class GameSupport
{	 
	Properties flags;
	
	public GameSupport()
	{
		flags = new Properties();
	}
	
	public void readFlags(String url)
	{
		try {
			URL src = new URL(url);
			InputStream in = src.openStream();
			flags.load(in);				

		} catch (Exception e)
			{ System.out.println("error loading flags from" + url + "\n" + e.toString()); }
	}
	
	public boolean refreshFlags(String url)
	{
		try {
			URL src = new URL(url);
			InputStream in = src.openStream();
			flags.load(in);		
			return true;	

		} catch (Exception e)
			{ 
				System.out.println("error loading flags from" + url + "\n" + e.toString()); 
				return false;
			}

	}	
	
	public int getUserOnline()
	{
		return Integer.parseInt(flags.getProperty("UserOnline"));
	}
	
	public int getPlayTime()
	{
		return Integer.parseInt(flags.getProperty("PlayTime")); 
	}	
	
	public int getActYear()
	{
		return Integer.parseInt(flags.getProperty("actYear")); 
	}		

	public int getForeSight()
	{
		return Integer.parseInt(flags.getProperty("foresightYears")); 
	}		
		
	
}
