/*
 * Norm.java
 *
 * Created on February 16, 2002, 3:07 PM
 */

package logica.utility;

/**
 *
 * @author  mash
 */

public class Norm
{

    
    public static float[] normalize(float[] values)
    {
        float max = (float) 0.0F;
        float[] valuesN = new float[values.length];        
        
        for (int i=0; i < values.length; i++)
        {
            max = Math.max(values[i],max);
        }  
        
        for (int i=0; i < values.length; i++)
        {
            valuesN[i] = values[i] / max;
        }          
        return valuesN;
    }


    
    public static float[] normalizeToSum(float[] values)
    {
		int valLen = values.length;
		float otherVal;
        float sum = 0.0F;
        float[] valuesN = new float[valLen];
		
		int zeroCount = 0;
		for (int i = 0; i < valLen; i++) {
			if (values[i] == 0.0F) zeroCount++;
			sum += values[i];
		}
        
		if (zeroCount >= (valLen - 1)) {
			otherVal = (1.0F - sum) / (float)(zeroCount);
			for (int i = 0; i < valLen; i++) {
				if (values[i] == 0.0F) valuesN[i] = otherVal;
				else valuesN[i] = values[i];
			}
		}
		else {
			for (int i=0; i < valLen; i++) valuesN[i] = values[i] / sum;
		}
		return valuesN;
    }

    

    public static float[] scaleLin(float[] values, float min, float max)
    {
        float v_min = (float) 0.0F;
        float v_max = (float) 0.0F;
        float[] valuesS = new float[values.length];
        
        
        for (int i=0; i < values.length; i++)
        {
            v_min = Math.min(v_min,values[i]);
            v_max = Math.max(v_max,values[i]);
        }  
        
        float diff = v_max - v_min;
        
        
        for (int i=0; i < values.length; i++)
        {
            valuesS[i] = min + (values[i] / (v_max - v_min) *  (max - min));
        }    
        return valuesS;
    }
    
}
