package logica.utility;

import logica.sim.*;
import logica.sim.data.*;



public class Utility {

	public boolean printDebugMsgs = true;
	public String debugMsgs = "";

	Year[] yrs = new Year[999];
	String[] yrComment = new String[999];
	int yrCount = 0;
	int[] yrTOfInterest = {};

	int msgCount = 0;
	Msg[] msgs = new Msg[999];
	Msg outOfMemMsg = new Msg(0, "out of memory for storage of messages");
	int[] msgOfInterest = {11};
	
	long oldMem = 0;


	public Utility (int[] yrOfIntArg) {
		if (yrOfIntArg.length > 0) yrTOfInterest = yrOfIntArg;
	}


	public void prMsg(Msg msgArg) {
		for (int i = 0; i < msgOfInterest.length; i++) {
			if (msgArg.type == msgOfInterest[i]) {
				System.out.println(msgArg.text);
			}
		}
	}


	public void addMsg (int typeArg, String textArg) {
//		if (Runtime.getRuntime().freeMemory() > 1000000) { 
//			if ((msgs.length - msgCount) < 2) {
//				Msg[] msgsT = new Msg[msgs.length + 100];
//				System.arraycopy(msgs,0,msgsT,0,100);
//				msgs = msgsT;
//			}
		
			msgs[msgCount++] = new Msg(typeArg, textArg);
			if (printDebugMsgs) prMsg(msgs[msgCount - 1]);
//		}
//		else {
//			System.out.println("out of Memory - addMsg " + textArg + " " + Runtime.getRuntime().freeMemory() 
//			                   + " " + memDiff());
//		}
	}


	public void addYr (int typeArg, Year yrArg, String textArg) {
//		if (Runtime.getRuntime().freeMemory() > 1000000) { 
//			if ((yrs.length - yrCount) < 2) {
//				Year[] yrsT = new Year[yrs.length + 100];
//				String[] yrCommentT = new String[yrComment.length + 100];
//				System.arraycopy(yrs,0,yrsT,0,yrs.length);
//				System.arraycopy(yrComment,0,yrCommentT,0,yrComment.length);
//				yrs = yrsT;
//				yrComment = yrCommentT;
//			}
			
			for (int i = 0; i < yrTOfInterest.length; i++) {
				if (typeArg == yrTOfInterest[i]) {
					yrs[yrCount] = new Year(yrArg.v);
					yrs[yrCount].isCopyOf(yrArg);
					
					yrComment[yrCount] = "Y: " + yrArg.v.calcYr + "  " + typeArg + "  " + textArg;
					yrCount++;
				}
			}
//		}
//		else {
//			System.out.println("out of Memory - addYr " + Runtime.getRuntime().freeMemory()
//			                   + " " + memDiff());
//		}
	}


	public class Msg {
		public int type;
		public String text;

		public Msg (int typeArg, String textArg) {
			type = typeArg;
			text = textArg;
		}
	}


	public void prMsgCount() {
		System.out.println(msgCount);
	}


	public String[] getComment(int startPos) {
		startPos = Math.max(startPos, 0);
		startPos = Math.min(startPos, yrCount - 2);

		int retLength = Math.min((yrCount - startPos - 1), 40);

		String[] returnMe = new String[retLength];
		System.arraycopy(yrComment,startPos,returnMe,0,retLength);
		return returnMe;
	}


	public float[] value(String nameOfVar, int regNr, int startPos) {
		startPos = Math.max(startPos, 0);
		startPos = Math.min(startPos, yrCount - 2);

		addMsg(1, "Utility.value");

		int retLength = Math.min((yrCount - startPos - 1), 40);

		float[] retValue = new float[retLength];

		if (nameOfVar.substring(0,2).equals("w.")) {
			for (int i = 0; i < retLength; i++) {
				retValue[i] = yrs[i + startPos].w.getValueRefl(nameOfVar.substring(2));
			}
		}
		else {
			for (int i = 0; i < retLength; i++) {
				retValue[i] = yrs[i + startPos].r[regNr].getValueRefl(nameOfVar);
			}
		}

		return retValue;
	}


	public String getName(int regNr) {
		return yrs[5].r[regNr].name;
	}


	public void getFirstNan() {
		String[] siAnsa = {};
		for (int i = 0; i < yrCount; i++) {
			for (int rNum = 0; rNum < yrs[i].r.length; rNum++) {
				siAnsa = yrs[i].r[rNum].getNaN();
				if (siAnsa.length > 0) {
					addMsg(8,"NaN oder Infinity");
					addMsg(8,"Region " + rNum + "   " + yrComment[i]);
					addMsg(8,"------ " + yrs[i].r[rNum].getName());
					for (int j = 0; j < siAnsa.length; j++) {
						try {
							addMsg(8, siAnsa[j] + " = " + yrs[i].r[rNum].getValueRefl(siAnsa[j]));
						} catch (Exception e) {
							System.out.println("bla");
						}
					}
					return;
				}
			}
		}
		addMsg(8,"kein NaN gefunden");
	}
	
	public long memDiff() {
		long mem = Runtime.getRuntime().freeMemory();
		long diff = oldMem - mem;
		oldMem = mem;
		return diff;
	}
}
